***********************
* TIMECLOCK_RAUKN.PRG *
***********************
* Tu s funkcie z TIMECLOCK.PRG ale upraven pre RAUKN prihlasovanie at.

* !!! Pozor, prklad z Xb2NET je pre Employee, ale ja potrebujem mj DBESYS
* tento musm nastavi v WEBSERVE

* pravy :
* Login upraven do Login_Raukn
* Logout treba tie upravi do Logout_Raukn, aby zatvrala moje databzy
* Logintest toto som skal treba preveri kde o pouvam, asi iba v prkladoch v Index hlavnej strnke

* Popis funkci :
* Header_Raukn - je hlavn horn menu

#include "xb2net.ch"
#include "common.ch"
#pragma  library ("xb2net.lib")

#xtranslate NTrim(<n>)        =>  LTrim(Str(<n>))

//#xtranslate Debug([<p,...>])  =>  QOut(<p>)
#xtranslate Debug([<p,...>])  =>

// security levels:
#define SEC_NONE          0
#define SEC_EMPLOYEE      1
#define SEC_SUPERVISOR    2
#define SEC_ADMIN         3


#xtranslate GETVAR <(name)> AS <var>     => Local <var> := oClient:GetVar(<(name)>)
#xtranslate GETCARGO <(name)> AS <var>   => Local <var> := oClient:GetCargo(<(name)>)
#xtranslate GETCOOKIE <(name)> AS <var>  => Local <var> := oClient:GetCookie(<(name)>)

#command WEBPROCEDURE <name>([<param,...>])         ;
         [VAR <(fname)> AS <fvar>]                  ;
         [COOKIE <(cname)> AS <cvar>]               ;
         [CARGO <(sname)> AS <svar>]                ;
            => PROCEDURE WEB_<name>(<param>)        ;
               ; Local oClient := ThreadObject()    ;
               [; GETVAR <(fname)> AS <fvar>]       ;
               [; GETCOOKIE <(cname)> AS <cvar>]    ;
               [; GETCARGO <(sname)> AS <svar>]

#command WEBPROCEDURE <name>([<param,...>])         ;
         PATH <path>                                ;
         [VAR <(fname)> AS <fvar>]                  ;
         [COOKIE <(cname)> AS <cvar>]               ;
         [CARGO <(sname)> AS <svar>]                ;
            => PROCEDURE WEB_<path>_<name>(<param>) ;
               ; Local oClient := ThreadObject()    ;
               [; GETVAR <(fname)> AS <fvar>]       ;
               [; GETCOOKIE <(cname)> AS <cvar>]    ;
               [; GETCARGO <(sname)> AS <svar>]

#command CHECKLOGIN ;
         => if ! isLoggedIn_Raukn() ;
         ;     return ;
         ;  endif

#command CHECKLOGIN SECURITY [<nSecLevel>] ;
         => if ! isLoggedIn_Raukn() .or. ! HaveSecurityPrivilege(<nSecLevel>) ;
         ;     return ;
         ;  endif


*qqq 24.9.2018 skka prihlsenia do Raukn, 
*               cez webserver
//-----------------------------------------------------------------------------
*****************************
WEBPROC Login_Raukn() PATH TC	// LoginRaukn je v Login_my na skku volan
*****************************
   GETVAR UID AS cUID
   GETVAR PWD AS cPWD

   Local lUpdate  := .t.
   Local cMessage := ""
   Local oServer  := oClient:Parent  // this is the xbHTTPServer object
   Local nID

   oClient:CloseSession()

   debug( "TC_Login 1: SID", oClient:GetSessionHandle(), "# Sess", xbSession():ActiveSessions(), "CARGO", oClient:GetCargo())

* ak nezadan iadny kd, tak znova ponkne login
   if Empty(cUID)
      // no user ID specified - redisplay login screen
      oClient:SendFile( oServer:RootDir + "\TC\Login_Raukn.htm" )
      Return
   endif

* predvolenie ciest, toto mus urobi NASTAV() z Raukn
* ale nateraz som dal IKUSERS do adresra DATA
PUBLIC cestadata	// tu dvam aby som vedel aj inde poui
cestahlprg:="d:\progsa\rauknw\"
cestaciselnik:=cestahlprg+"ciselnik\"
cestadata:="c:\#VYVOJ\Xb2NET_MOJE\data\"

* otvorenie databzy, Opendbf je v TimeClock funkcia, treba upravi, preloi chybov hlsenie
* syntax databza, alias, index
* OpenDBF( "EMPLOYEE", "EMP", "EMPLOYEE")

* POZOR , tu na DBE, ktor pouijem,pre RAUKN musm FOXCDX , ale pre XB2 demo je DBFCDX, vi v WEBSERVE.PRG
* tam som doplnil svoj DBESYS a pvodn demo som zablokoval

* Funkcia OpenDBF (databzov sbor, alias, indexov sbor !, tj. nie index.k)
* priom databzy s tu zatia : c:\#VYVOJ\Xb2NET_MOJE\data\
*  OpenDBF( "IKUSERS", "IKUSR", "IKUSERS")
*  OpenDBF( cestaciselnik+"IKUSERS", "IKUSERS", cestaciselnik+"IKUSERS")
   OpenDBF( cestadata+"IKUSERS", "IKUSR", cestadata+"IKUSERS")

* tu sa alej nedostanem, musim poriei vea vec vrtane kryptovania, eXpress prilinkovania at.

* tu uprav kd uvatea na slo, ale ak mm v Raukn povolen aj znakov pole, tak musm prispsobi
* blokujem konverziu na Val, lebo kd uvatea mm v databze Char.
*  nID := Val(cUID)
   nID := alltrim(cUID)	// ale iba ho upravm

* kontrola sprvnosti hesla, tu musm riei kryptovanie ktor mm pouit

* ak nesprvne heslo tak preru 

* tu iba pokusne zablokujem, aby som sa dostal do alieho "levelu"
/*
   * ak nesprvne heslo ? 
   if !(DbSeek(nID, .f.) .and. Upper(Trim(emp->password)) == Upper(Trim(cPWD)))
      // invalid userid/password - go back to login screen
      dbCLoseAll()
      oClient:SendFile( oServer:RootDir + "\TC\Login_Raukn.htm" )
      Return
   else

   endif
*/

* tu sksim iba pretestova kd uvatea ale neviem, ako funguje DbSeek ak order  nenastaven ?
*qqq 2.11.2018 tu dopam order, lebo v pvodnom prklade bol iba jeden index key, ja mm dva
set order to 1
* ak nenaiel takho uvatea
if !(DbSeek(nID, .f.))
	tone(200,5)
	// invalid userid/password - go back to login screen
      	dbCLoseAll()
      	oClient:SendFile( oServer:RootDir + "\TC\Login_Raukn.htm" )
      	Return
*ak naiel uvatea
else
	tone(1000,3)
endif
*

   // we have a valid userid/password = mm platn uv.meno a heslo

   // make sure any previous session is properly closed - zaistm, aby predch.session bola korektne zatvoren
   oClient:CloseSession()

   // the GetCargo/SetCargo methods will automatically open a new session to keep track of this guy
   // automaticky otvor nov session na pokraovanie sledovania tohto uvatea	
	
   if oClient:GetCargo("UID") != NIL
      if oClient:GetCargo("UID") == nID
         // same guy, don't update login count in password table
         lUpdate := .f.
      else
         // this client was previously logged in under a different userid
         // close the old session
         oClient:CloseSession()
      endif
   endif

* tu asi ulom do premennch hodnoty UID,...
* ??? oje SetCargo asi uklad hodnoty do premennch
*  oClient:SetCargo("UID"       , nID)
*  oClient:SetCargo("NAME"      , AllTrim(emp->MName + " " + Trim(emp->FName) + " " + emp->LName))
*  oClient:SetCargo("SECURITY"  , emp->security)  // save the security level, tu je numeric 1
*  oClient:SetCargo("EXCEPTIONS", emp->(GetExceptions()))

* tu natam hodnoty pol asi do premennch, ktor viem potom poui
   oClient:SetCargo("UID"       , nID)	//	 prihlasovac kd
   oClient:SetCargo("NAME"      ,AllTrim(Trim(IKUSR->USR_TIT)+" "+Trim(IKUSR->USR_MENO)+" "+Trim(IKUSR->USR_PRI)))	// meno uvatea cel komplet s titulom...
*  oClient:SetCargo("SECURITY"  , 1)	// predvolm 1, lebo zatia nevyuvam
   oClient:SetCargo("SECURITY"  , 3)	// predvolm 3 aby som videl aj ADMIN menu funkcie
   oClient:SetCargo("EXCEPTIONS", "")	// tu napr. nejak kontrola ak napr. sa posledne neodhlsil a pod. predvoujem przdny znak

* tu u vyhodnocuje ale ja toto tu nepotrebujem preto iba predvolm hodnoty premennch pre SetCargo
/*
   if emp->DATE_IN == date()
      oClient:SetCargo("CLOCKIN" , emp->time_in)
   endif

   if emp->DATE_OUT == date() .and. emp->time_out >= emp->time_in
      oClient:SetCargo("CLOCKOUT", emp->time_out)
   endif
*/
* iba aby som naplnil premenn pre Cargo
      oClient:SetCargo("CLOCKIN" , "")	// neviem ak hodnotu tu mm da v akom formte sksim przdnu
      oClient:SetCargo("CLOCKOUT", "")

* tu je samotn zpis do databzy, toto zatia zablokujem
/* ale blokujem, aby ni do databzy nezapisoval, neskr mem poui napr. pre zpis ak sa uvate prihlsi
   // update the login count if user was not already logged in
   if lUpdate .and. dbRLock()
      emp->nLogins   := emp->nLogins + 1
      emp->LogInDate := date()
      emp->LogInTime := time()
   endif
*/

* zatvorenie databzy
   dbCLoseAll()

   debug( "TC_Login 2: SID", oClient:GetSessionHandle(), "# Sess", xbSession():ActiveSessions(), "CARGO", oClient:GetCargo())


*qqq 20.11.2018 toto ukka, ako zobrazi klientovi obsah resp. strnku ktor je uloen na serveri - ok funguje
*oClient:SendFile( oServer:RootDir + "\Ahoj_html.htm" )

*qqq 20.11.2018 toto je pokusn otestovanie poslania nejakho oznamu klientovi priamo v html kde - ok funguje
*oClient:HTTPResponse:Content := ;
*      '<html><body>Sprva od Login_Raukn po prihlsen</body></html>'

* tu u posiela klientovi strnku, ktor vygeneroval DrawOuterFrame_Raukn, kde je vytvoren menu, at u pre 
* konkrtne prihlsenho uvatea
   // attach the response string to the HTTP response object
   oClient:HTTPResponse:Content := DrawOuterFrame_Raukn( oClient:GetSessionHandle() )

tone(1000,3)

Return

* tto funkciu musm upravi pre IKUSERS... ale tto funkcia sa vol iba ak u zo samotnej aplikcie LOGOUT tlatko
//-----------------------------------------------------------------------------
// Close session and exit TimeClock app. Client browser is taken back to Login screen.
//
WEBPROC Logout_Raukn() PATH TC

   GETVAR UID AS nID				// tu asi preto neulo do nID, lebo mm zle v Login nzov Login a nie Login_Raukn sksi

*skam o tu vyhodnot SID, ale nie, neviem preo tu nevie asi oClient nepozn
Local test2SID:= oClient:GetSessionHandle()
Local test2Cargo:= oClient:GetCargo()
if empty(test2SID)
	test2SID:="SID nezisten"
endif
if empty(test2Cargo)
	test2Cargo:="GetCargo nezisten"
endif

* tu zistenie obsahu celho CARGO tj. vetkch existujcich premennch s hodnotami
testCargox:=""
* tu zistenie obsahu celho CARGO tj. vetkch existujcich premennch s hodnotami
for i=1 to len(test2Cargo)
	if len(test2Cargo[i])>1
		for j=1 to len(test2Cargo[i])
			si=alltrim(str(i))
			sj=alltrim(str(j))
			testCargox+="[ij"+si+"]["+sj+"]["+var2char(test2Cargo[i,j])+"]   "
		next
	else
			si=alltrim(str(i))
			sj=alltrim(str(j))
			testCargox+="[i"+si+"]["+sj+"]["+var2char(test2Cargo[i])+"]   "
	endif
next
testhodnoty:=test2SID+"/"+testCargox

/* tu skam zisti UID aj takto cez GetCargo, a funguje to !
pomUID:=oClient:GetCargo("UID")
if empty(pomUID)
	pomUID="pomUID nezisten"
endif
testhodnoty:=testhodnoty+"<"+pomUID+">"
*/

* zatvorenie session
oClient:CloseSession()

* tu upravi aby zatvral moju databzu IKUSERS
   OpenDBF( "EMPLOYEE", "EMP", "EMPLOYEE")

* tu naprklad zape dtum a as logoutu, 
   if DbSeek(nID) .and. dbRLock()
      emp->LogOutDate := date()
      emp->LogOutTime := time()
   endif

   dbCLoseAll()
	
   * zobrazenie oznamovacieho okienka, ostane x seknd poda poslednho parametra, ale iba jeden oznam sa zobraz, tj. tu sa ned viac
   * oznamov za sebou da

*  FlashMessage( "You are now logged out...", "/", 2)				// pvodn oznam
*  FlashMessage( "Logout_Raukn-Odhlsili ste sa z aplikcie RAUKN...", "/", 2)		// prava pre Raukn
   FlashMessage( "Logout_Raukn-Odhlsili ste sa z aplikcie RAUKN,CARGO="+testhodnoty, "/", 5)	// tu skam zobrazi pomUID, zisten cez GetCargo , funguje

   debug( "TC_Logout: SID", oClient:GetSessionHandle(), "# Sess", xbSession():ActiveSessions(), "CARGO", oClient:GetCargo())

   Return

*qqq 12.11.2018 toto je funkcia,ktor iba pokusne sksim na zistenie vybranho kat.zemia
//-----------------------------------------------------------------------------
// Close session and exit TimeClock app. Client browser is taken back to Login screen.
//
WEBPROC Logout_Raukn_ku() PATH TC

   GETVAR UID AS nID		// toto zisuje ako zadal uvate , teda myslm si

				// a ostatn parametre viem zisti cez CARGO, lebo tie s zisten na serveri i ???
*GETVAR RCTRLTEST AS cRCTRLTEST	// ale toto nesprav ni
*GETCARGO OKRES AS cOKRES

*skam o tu vyhodnot SID, ale nie, neviem preo tu nevie asi oClient nepozn
Local test2SID:= oClient:GetSessionHandle()
Local test2Cargo:= oClient:GetCargo()
if empty(test2SID)
	test2SID:="SID nezisten"
endif
if empty(test2Cargo)
	test2Cargo:="GetCargo nezisten"
endif

* tu zistenie obsahu celho CARGO tj. vetkch existujcich premennch s hodnotami
testCargox:=""
* tu zistenie obsahu celho CARGO tj. vetkch existujcich premennch s hodnotami
li=len(test2Cargo)
tli="(li="+alltrim(str(li))+")"
for i=1 to li
	lj=len(test2Cargo[i])
	tlj="(lj="+alltrim(str(lj))+")"
	testCargox+=(tli+tlj)
	if lj>1
		for j=1 to lj
			si=alltrim(str(i))
			sj=alltrim(str(j))
			testCargox+="[ij"+si+"]["+sj+"]["+var2char(test2Cargo[i,j])+"]   "
		next
	else
			si=alltrim(str(i))
			sj=alltrim(str(j))
			testCargox+="[i"+si+"]["+sj+"]["+var2char(test2Cargo[i])+"]   "
	endif
next
testhodnoty:=test2SID+"/"+testCargox

/* tu skam zisti UID aj takto cez GetCargo, a funguje to !
pomUID:=oClient:GetCargo("UID")
if empty(pomUID)
	pomUID="pomUID nezisten"
endif
testhodnoty:=testhodnoty+"<"+pomUID+">"
*/

   oClient:CloseSession()

* tu sksim miesto Login da Logout_raukn_ku
*   debug( "TC_Login 1: SID", oClient:GetSessionHandle(), "# Sess", xbSession():ActiveSessions(), "CARGO", oClient:GetCargo())
   debug( "TC_Logout_raukn_ku 1: SID", oClient:GetSessionHandle(), "# Sess", xbSession():ActiveSessions(), "CARGO", oClient:GetCargo())

* tu upravi aby zatvral moju databzu IKUSERS
  OpenDBF( "EMPLOYEE", "EMP", "EMPLOYEE")

* tu naprklad zape dtum a as logoutu, 
  if DbSeek(nID) .and. dbRLock()
     emp->LogOutDate := date()
     emp->LogOutTime := time()
   endif

   dbCLoseAll()

   * zobrazenie oznamovacieho okienka, ostane x seknd poda poslednho parametra, ale iba jeden oznam sa zobraz, tj. tu sa ned viac
   * oznamov za sebou da

*  FlashMessage( "You are now logged out...", "/", 2)				// pvodn oznam
*  FlashMessage( "Logout_Raukn_ku-Odhlsili ste sa z aplikcie RAUKN...", "/", 2)		// prava pre Raukn
*  FlashMessage( "Logout_Raukn_ku-Odhlsili ste sa z aplikcie RAUKN..."+pomUID, "/", 2)	// tu skam zobrazi pomUID, zisten cez GetCargo , funguje
*  FlashMessage( "Logout_Raukn_ku-Odhlsili ste sa z aplikcie RAUKN..."+nID+cRCTRL+cRCTRL+cRCTRLTEST+cCLOCKOUT, "/", 5)	// tu skam zobrazi pomUID, zisten cez GetCargo , funguje

   FlashMessage( "Logout_Raukn_ku-Odhlsili ste sa z aplikcie RAUKN,CARGO="+testhodnoty, "/", 5)	// tu skam zobrazi pomUID, zisten cez GetCargo , funguje

   debug( "TC_Logout: SID", oClient:GetSessionHandle(), "# Sess", xbSession():ActiveSessions(), "CARGO", oClient:GetCargo())

   Return

* toto je u funkcia ktor 
//-----------------------------------------------------------------------------
// After a user successfully logs in, this function will draw the outer frameset
// for the TimeClock app. This frameset contains a small 'header' frame along the
// top for common hyperlink shortcuts and a 'main' frame where the TimeClock app
// will be drawn.
//
// Although we can use client-side "cookies" to perform session management automatically.
// This will fail when a client has cookie support turned off. To make it work for all
// cases we need to pass the unique session handle within each URL hyperlink pointing
// back to the server.
//

* FUNKCIA PRE VYTVORENIE ZKLADNHO FRAME - prava pre RAUKN
************************************************************
* vytvra zkladn strnku a potom vol Header_Raukn a TimeClock_Raukn

*********************************************************
STATIC FUNCTION DrawOuterFrame_Raukn( cSessionHandle )
*********************************************************

   Static cTemplate

   *asi ak ete nie je vytvoren
   if cTemplate == NIL

      *vygenerovanie zkladnho frame, tj. zkladnej asi strnky

      TEXT INTO cTemplate TRIMMED
      <!doctype html public "-//w3c//dtd html 4.0 frameset//en">
      <html>

      <head>
        <title>TimeClock_Raukn</title>
        <meta name=viewport content="width=device-width, initial-scale=1">
        <link rel="stylesheet" media="screen" type="text/css" href="/style.css">
        <style type="text/css">
        body {margin:0;}

        #red {position:absolute;
              top:0; left:0;
              width:100%;
              background-color:#f30;}
        </style>
        </head>

      <frameset rows="26,*" frameborder=no border=0>
        <frame name=header src=Header_Raukn?<%sid%> marginwidth=0 marginheight=0 frameborder=no scrolling=no noresize>
        <frame name=main   src=TimeClock_Raukn?<%sid%> marginwidth=0 marginheight=0 frameborder=no scrolling=auto>
        </frameset>

      <noframes>
        <body>
        <div id="red"></div>
        <center>
        <br><br><br>
        This page uses frames.<br>
        Your browser either does not support frames or you have turned frame support off.<p>
        <b><a href="TimeClock_Raukn?" target="_top">click here to continue without frames</a></b>
        </center>
        </body>
        </noframes>

      </html>
      ENDTEXT
   endif

   Return StrTran(cTemplate, "<%sid%>", "_SID=" + cSessionHandle)

* toto asi iba upozornenia, ak v prklade sa neprihlsi alebo neodhlsi z dochdzky
//-----------------------------------------------------------------------------
STATIC FUNCTION GetExceptions()

   if field->date_in < date() .and. field->date_out < field->date_in
      Return "<b>* NOTE *</b><p>You forgot to clock out on " + dtoc(field->date_in)
   endif

   if field->date_out < date() .and. field->date_out > field->date_in
      Return "<b>* NOTE *</b><p>You forgot to clock in on " + dtoc(field->date_out)
   endif

   if field->date_out = date() .and. field->date_in < date()
      Return "<b>* NOTE *</b><p>You forgot to clock in today!"
   endif

   Return ""


* toto asi vade musm upravi poda seba 
//----------------------------------------------------------------------------------------------------
STATIC FUNCTION OpenDBF( cFile, cAlias, cIndex )
   Local i := 0

   DEFAULT cAlias TO cFile

   for i := 1 to 10   // try for a max 5 sec
      if cIndex == NIL
         use (cFile) alias (cAlias) shared new
      else
         use (cFile) alias (cAlias) index (cIndex) shared new
      endif
      if ! NetErr()
         Return .t.
      endif
      sleep( 50 )
   next

   dbCLoseAll()
   Break( "Neviem otvori databzov sbor " + cFile)       // this will cause an error to be returned to the client
   Return .f.

* toto je ovldanie, tj. texty nies nzvy poloiek ale vybran akcie, tj. nzvy funkci
//-----------------------------------------------------------------------------
WEBPROC TimeClock_Raukn() PATH TC
//-----------------------------------------------------------------------------
   GETCARGO UID    AS nID

   GETVAR   ACTION AS cAction

*qqq3 sksim tu da, lebo ke Browsetable_Raukn vol tto funkciu, tak by jej mal posla hodnoty
* NEFUNGUJE TO TU !!!
*  GETVAR TESTRCTRL AS c1TESTRCTRL
*  GETCARGO TESTRCTRL AS c2TESTRCTRL

   Local cTime, cFilter, cDate, aParam

*qqq3 nefunguje, tj. tu neviem zisti hodnoty
*c1TESTRCTRL:=oClient:=GetVar("TESTRCTRL")
*c2TESTRCTRL:=oClient:=GetCargp("TESTRCTRL")

*if empty(c1TESTRCTRL)
*	c1TESTRCTRL:="[c1empty]"
*endif
*if empty(c2TESTRCTRL)
*	c2TESTRCTRL:="[c2empty]"
*endif
*cTESTRCTRL:=c1TESTRCTRL+c2TESTRCTRL

   debug( "TimeClock: SID", oClient:GetSessionHandle(), "# Sess", xbSession():ActiveSessions(), "CARGO", oClient:GetCargo())

   CHECKLOGIN

   Debug("Action:", cAction, oClient:GetCargo())

   DEFAULT cAction TO ""

* pvodn rieenie
*  cAction := Upper(cAction)

* skam pravu do textu bez diakritiky, ale niekde sa d nastavi kdov strnka pre HTML...
**************************************************************
   cAction := Upper(lat_ibm_u_o(cAction))
**************************************************************

* pozor, toto nie s texty menu zobrazovan v ponuke ale ovldanie cez cAction
* priom asi ACTION odovzdva internetov prehliada Webserveru ako hodnotu ACTION
* pre do case, tj. mus by zhoda v tom o je pre prehliada v HTML a tu 

* Tu u vber voby funkcie, ktor alej odkazuj na ? o 
* tu zatia tri verzie, pvodn, bez diakritiky a sdiakritikou, ktor musm inak oetri cez LAT_IBM
do case
*******

* zadanie prchodu
******************
* case cAction == "CLOCK IN"
* case cAction == "PRCHOD"
  case cAction == "PRICHOD"			// ak ani tak nepjde tak tu sksi da text bez diakritiky

      cTime := SaveTimeClock( nID, 1 )		// zavol funkciu SaveTimeClock, ktor prid do databzy as prchodu
      oClient:SetCargo("CLOCKIN", cTime)	// ulo hodnotu do session ? funkcia Xbase++ ale pozor, pe e iba Proffesional ?
						// CLOCKIN sa alej d poui asi na zobrazenie na web strnke 
* zadanie odchodu
*****************
*  case cAction == "CLOCK OUT"
   case cAction == "ODCHOD"

      cTime := SaveTimeClock( nID, 2 )
      oClient:SetCargo("CLOCKOUT", cTime)	// ako vyie, 
      // display timeclock page for 5 seconds, then logout user
      oClient:HTTPResponse:Refresh("5; URL=Logout_Raukn?_SID=" + oClient:GetSessionHandle())	// toto neviem o rob asi zavol funkciu pre zobrazenie 
												// oznamu, e sa user odhlsil												
* zruenie poslednho prchodu
******************************
*  case cAction == "CANCEL LAST CLOCK IN"
*  case cAction == "ZRU POSLEDN IN"
   case cAction == "ZRUS POSLEDNY IN"

      cTime := SaveTimeClock( nID, 3 )	// ako vyie
      oClient:SetCargo("CLOCKIN", "")

* zruenie poslednho odchodu
******************************
*  case cAction == "CANCEL LAST CLOCK OUT"
*  case cAction == "ZRU POSLEDN OUT"
   case cAction == "ZRUS POSLEDNY OUT"

      cTime := SaveTimeClock( nID, 4 )	// ako vyie
      oClient:SetCargo("CLOCKOUT", "")

* zmena hesla
**************
*  case cAction == "CHANGE PASSWORD"
   case cAction == "ZMENA HESLA"

      WEB_TC_ChangePasswordForm()	// vola funkciu ktor zobraz znova web okno a alej ete vol ChangePassword

      Return

* zobrazenie pracovnho tda, v browse tabuke
************************************************
*  case cAction == "VIEW WORK WEEK"
*  case cAction == "POZRI PRACOVN TݎDE"
   case cAction == "POZRI PRACOVNY TYZDEN"

      * nastavenie dtumu, aby zobrazilo iba aktulny tde 	
      cDate := dtos(Date() - DoW(Date()) + 1)  // date of start of week

*pozn. tu u prklad havaruje, lebo nemm hodnoty asi Date_in at. z mojej IKUSERS databzy a chcem otvori zase in databzu
* toto prispsobi pre moju databzu ,napr. RAUKN_OLP
      * nastavenie filtra aby asi zobrazilo iba daje prihlsenho uvatea ?
      cFilter := "{||field->ID=" + NTrim(nID) + ".and.(dtos(field->date_in)>='" + cDate + "'.or.dtos(field->date_out)>='" + cDate +"')}"

      * tu u vygenerovanie array tj. poa, ktor odovzd funcii BrowseTable
      //aParam := {"TCLOCK", "ID", Str()"Work Week", nil, &(cFilter) }
      aParam := {"TCLOCK", "ID", Str(nID,10), Str(nID,10), "Work Week for: " + oClient:GetCargo("NAME"), nil, &(cFilter)}

      * zobrazenie tabuky v browseri, 	
      WEB_TC_BrowseTable( xbBase64Encode(var2char(aParam)) )	// vola Browsetable s parametrami hlaviky tabuky
								// tto potom alej vol DrawTableGrid
								// tu iba jednoduch otvorenie cez USE, ale ja musm aj index at, 
								// relcie riei, prpadne SQL, take DrawTableGrid musm prispsobi
*qqq2  ale preo tu nie je return ?

*qqq2
* TEST KOMUNIKCIE
****************************************
   case cAction == "TEST KOMUNIKACIE"

      *cTime := SaveTimeClock( nID, 2 )
	
      ctestkom:="ABCDEFGH"		// nastavenie premennej pre odoslanie
      oClient:SetCargo("TESTKOM", ctestkom)	// ako vyie, 

      // display timeclock page for 5 seconds, then logout user
      oClient:HTTPResponse:Refresh("5; URL=Logout_Raukn?_SID=" + oClient:GetSessionHandle())	// toto neviem o rob asi zavol funkciu pre zobrazenie 

* skka browsera selnka kat.zem
*******************************************
    case cAction == "VYBER KATASTRALNE UZEMIE"
		
*qqq3 tu pridvam 9 ty parameter TESTRCTRL
		cFilter  := "{||NIL}"	// nezapnam iadny filter
		aParam := {cestadata+"RKU807", "CISKU", 800490, 836915, "Katastrlne zemia : ", NIL, NIL,oClient:GetCargo("NAME"),oClient:GetCargo("TESTRCTRL")}
		* tu odovzdvam parametre : 
		*	   cTable     := aParam[1] - nzov databzy	
		*	   xTag       := aParam[2] - order, napr. CISKU, NAZOV
		*	   xTopScope  := aParam[3] - scope ak napr. chcem cez scope filtrova alebo napr. od 800490 do 836915
		*	   xBotScope  := aParam[4] - dtto
		*	   cHeading   := aParam[5] - hlavika tabuky browsera  
		*	   aFields    := aParam[6] - polia, ak przdne, tak vyberie vetky polia
		*	   bFilter    := aParam[7] - filtrovanie, toto nepouva ak nemusm, lebo filter je pomal
		*	   cName      := aParam[8] - pokusne som tu poslal NAME
				
*qqq3 a tu sksim da do Carga, o poslal browsetable_raukn pri ukonen

      ctestrctrl:="IJKLMNO"		// nastavenie premennej pre odoslanie
      oClient:SetCargo("TESTRCTRL", ctestrctrl)	// ako vyie, 

      * zobrazenie tabuky v browseri, 	 tto funkcia by mala by univerzlna
      WEB_TC_BrowseTable_raukn( xbBase64Encode(var2char(aParam)) )	// vola Browsetable s parametrami hlaviky tabuky
									// tto potom alej vol DrawTableGrid
									// tu iba jednoduch otvorenie cez USE, ale ja musm aj index at, 
									// relcie riei, prpadne SQL, take DrawTableGrid musm prispsobi

* POZOR , ak v BrowseTable pouijem closesession tak vlastne zatvorm komunikan kanl a otvoren strnka zmizne
*         vi v Logout je closesession, ak by nebolo tak ostane otvoren

*qqq2 ak tu nedm return tak sce asi hne vytvor strnku Browsetable, ale dole sko na stredn menu okno, take
*     sa browser nezobraz, preto tu return musm da aby neiel na niie HTTPResponse pre znovuzobrazenie menu
      Return

* odhlsenie
*************
*  case cAction == "EXIT"
   case cAction == "KONIEC"

      WEB_TC_Logout()	// tu zatv
      Return

* koniec case
endcase
***********

*qqq2 tu upravujem volan parametre TESTRCTRL a TESTKOM

* ak vyie nevolan in funkcia tak asi aktualizcia tak zobrazenie html okna a aktualizcia hodnt NAME, CLOCKIN,...
* tj vola BuildTimeClockPage_Raukn
   oClient:HTTPResponse:Content := BuildTimeClockPage_Raukn(;
                                       oClient:GetCargo("NAME"), ;
                                       oClient:GetCargo("CLOCKIN"), ;
                                       oClient:GetCargo("CLOCKOUT"), ;
                                       oClient:GetCargo("EXCEPTIONS"), ;
                                       oClient:GetCargo("TESTRCTRL"), ;	
                                       oClient:GetCargo("TESTKOM") ;	
					)

   Return


* aj toto potrebujem tu pre TimeClock_Raukn
//-----------------------------------------------------------------------------
STATIC FUNCTION isLoggedIn_Raukn()
   if Empty(ThreadObject():GetCargo("UID"))
      ThreadObject():CloseSession()
      FlashError("Najprv sa muste prihlsi...", "Login_Raukn.htm")
      Return .F.
   endif
   Return .T.

//-----------------------------------------------------------------------------
STATIC FUNCTION SaveTimeClock( nID, nAction )
   Local cTime := Left(Time(),5)

   OpenDBF( "EMPLOYEE", "EMP", "EMPLOYEE")
   OpenDBF( "TCLOCK"  , "TC" , "TCLOCK"  )

   if emp->(DbSeek(nID)) .and. emp->(LockRecord())
      do case
      case nAction == 1                // clock in
         if tc->(DbSeek(str(0,10))) .and. tc->(dbRLock())
            // recycle deleted record
         else
            tc->(dbAppend())
         endif
         tc->ID      := nID
         tc->DATE_IN := emp->DATE_IN := Date()
         tc->TIME_IN := emp->TIME_IN := cTime

      case nAction == 2                // clock out
         if tc->(DbSeek( STR(nID,10) + DTOS(emp->DATE_IN) + emp->TIME_IN ))
            if tc->(LockRecord())
               tc->DATE_OUT := emp->DATE_OUT := Date()
               tc->TIME_OUT := emp->TIME_OUT := cTime
            endif
         else
            tc->(dbAppend())
            tc->ID       := nID
            tc->DATE_IN  := emp->DATE_IN
            tc->TIME_IN  := emp->TIME_IN
            tc->DATE_OUT := emp->DATE_OUT := Date()
            tc->TIME_OUT := emp->TIME_OUT := cTime
         endif

      case nAction == 3                // cancel clock in
         if tc->(DbSeek( STR(nID,10) + DTOS(emp->DATE_IN) + emp->TIME_IN )) .and. tc->(LockRecord())
            tc->ID      := 0
            tc->DATE_IN := tc->DATE_OUT := ctod("")
            tc->TIME_IN := tc->TIME_OUT := ""
         endif
         emp->DATE_IN := ctod("")
         emp->TIME_IN := ""

      case nAction == 4                // cancel clock out
         if tc->(DbSeek( STR(nID,10) + DTOS(emp->DATE_IN) + emp->TIME_IN )) .and. tc->(LockRecord())
            tc->DATE_OUT := ctod("")
            tc->TIME_OUT := ""
         endif
         emp->DATE_OUT := ctod("")
         emp->TIME_OUT := ""

      endcase
   endif

   dbCLoseAll()

   Return cTime

* aj toto som musel upravi akoby boli dve verzie okna prchodov odchodov
* tu asi toto prve je rieenie e ke vyberiem nejak funkciu , tak jej nzov ide do hodnoty pre ACTION
* a alej sa potom vyhodnot v TimeClock
* tj. tu sa zobraz ponuka, a potom poda toho o kliknem sa odovzd hodnota (action) funkcii TimeClock ktor porovn v CASE a spracuje

* !!! Pozor, asi to m problm s diakritikou preto musm riei inak, napr. LAT_IBM a potom spracova
//--------------------------------------------------------------------------------------------------
STATIC FUNCTION BuildTimeClockPage_Raukn( cName, cTimeIn, cTimeOut, cExceptions,ctestrctrl,ctestkom)
//--------------------------------------------------------------------------------------------------
   Static cTemplate
   Local cHtml

   DEFAULT cTimeIn     TO ""
   DEFAULT cTimeOut    TO ""
   DEFAULT cExceptions TO ""

*qqq tu pridanie test komunikacie
   if cTemplate == NIL
      TEXT INTO cTemplate TRIMMED
      <html>
      <head>
        <title>TimeClock</title>
        <style>
         td {font:normal 16px verdana; color:white; text-align:left;}
         td.head {font: bold 18px verdana; color:magenta; align:center; }
         td.foot {padding:20; color:yellow; align:center; }
         input {width:220px; font:bold 16px verdana; color:navy; text-align:left;}
         input.disabled {color:gray;}
        </style>
      </head>

      <body bgcolor=black>
        <table width=100% height=100%>
          <tr><td align=center>

          <table width=400 height=380 align=center style='background-color:#036;'>
            <tr><td valign=center>

            <table align=center>
              <tr><td class=head><%name%></td></tr>
              <tr><td><%date%><br><br></td></tr>

               <form name="tc" method="get" action="TimeClock_Raukn">
                 <input type=hidden name="_SID" value="<%sid%>">
                 <tr><td><input <%disabled%> type=submit name="action" value="Prchod" accesskey="I"></td><td>&nbsp;<%timein%></td></tr>
                 <tr><td><input type=submit name="action" value="Odchod" accesskey="O"></td><td>&nbsp;<%timeout%></td></tr>
                 <tr><td><input type=submit name="action" value="Zru posledn <%inout%>" accesskey="C"></td></tr>
                 <tr><td><input type=submit name="action" value="Zmena hesla" accesskey="P"></td></tr>
                 <tr><td><input type=submit name="action" value="Pozri pracovn tde" accesskey="V"></td></tr>
                 <tr><td><input type=submit name="action" value="Test komunikcie" accesskey="T"></td><td>&nbsp;<%testkom%></td></tr>
                 <tr><td><input type=submit name="action" value="Vyber katastrlne zemie" accesskey="V"></td><td>&nbsp;<%testrctrl%></td></tr>
                 <tr><td><input type=submit name="action" value="Koniec" accesskey="X"></td></tr>
               </form>

            </table>
            </td></tr>

            <tr><td class=foot><%exceptions%></td></tr>

          </table>
          </td></tr>
        </table>
      </body>
      </html>
      ENDTEXT
   endif

* nahradenie pomocnch premennch v <%%> za hodnoty ktor mm v parametroch 
   cHtml := StrTran(cTemplate, "<%sid%>"    , ThreadObject():GetSessionHandle(), 1, 1)
   cHtml := StrTran(cHtml, "<%name%>"       , cName, 1, 1)
   cHtml := StrTran(cHtml, "<%date%>"       , dtoc(date()), 1, 1)
   cHtml := StrTran(cHtml, "<%date%>"       , dtoc(date()), 1, 1)
   cHtml := StrTran(cHtml, "<%timein%>"     , cTimeIn, 1, 1)
   cHtml := StrTran(cHtml, "<%timeout%>"    , cTimeOut, 1, 1)
   cHtml := StrTran(cHtml, "<%exceptions%>" , cExceptions, 1, 1)

*qqq2
   cHtml := StrTran(cHtml, "<%testkom%>"     , ctestkom, 1, 1)
   cHtml := StrTran(cHtml, "<%testrctrl%>"   , ctestrctrl, 1, 1)

   if empty(cTimeIn) .or. (!empty(cTimeOut) .and. cTimeOut > cTimeIn)
      cHtml := StrTran(cHtml, "<%disabled%>", "", 1, 1)
      cHtml := StrTran(cHtml, "<%inout%>", "Out", 1, 1)
   else
      cHtml := StrTran(cHtml, "<%disabled%>", "class=disabled disabled", 1, 1)
      cHtml := StrTran(cHtml, "<%inout%>", "In", 1, 1)
   endif

   Return cHtml

* Tu zata browser tabuky, parametre ako nzov tabuky, at dostal z funkcie TimeClock_Raukn
//--------------------------------------------------------------------------------------------
**************************************************
WEBPROC BrowseTable_Raukn( cBase64String ) PATH TC
**************************************************
   Local cHtml

   CHECKLOGIN		// kontrola i uvate prihlsen, iba tak povol otvorenie 

*qqq 6.11.2018 skam upravi poda seba aby vyfarbovalo riadky a diakritika doplnenie kdovania
* + pridvam aj java script setrow pre vber riadku ale typ radio pre pokus
/*
   TEXT INTO cHtml TRIMMED
      <html><head>
      <link rel="stylesheet" type="text/css" href="/Style.css"></head>
      <body bgcolor=black style=margin:0;>
   ENDTEXT
*/

**********************************************************************
* TU JE ZAIATOK HTML STRNKY, HLAVIKA, NASTAVENIA - BLOK HTML KDU *
**********************************************************************
TEXT INTO cHtml TRIMMED

<html>
	<head>
	  <title>Vber katastrlneho zemia</title>
	  <meta charset="Windows-1250">
	  <link rel="stylesheet" type="text/css" href="/Style.css">
	</head>
	<body bgcolor=black style=margin:0;>

ENDTEXT
************************************************************************

********************************************************************************************************
* TU S FUNKCIE JAVASCRIPT , PRID A NA KONCI VYTVORENIA STRNKY PRED /BODY - BLOK JAVASCRIPT FUNKCI *
********************************************************************************************************
* tento obsah me by aj v samostatnom sbore, napr. raukn.js, a mem ho vola cez <script src="raukn.js"></script>

TEXT INTO cHtml_javascript TRIMMED

<!-- skripty pre ovldanie browsera -->

<!-- 1. zmena farby riadku na ktorom je alebo prechdza kurzor, toto funguje bez nutnosti akejkovek alej funkcie -->
<!-- OK POUVA SA , FUNGUJE -->
<style>
    table tr:hover td {background:#EDB01C;color:#191970}
</style>

<!-- riei vyznaovanie radio checkboxu ak kliknem hocikde na riadku, vi odvolva sa na to TR table row , tj. tr onclick="HandleRadioRow()" -->
<!-- 1.FUNGUJE -->
<script type="text/javascript">
	var vybku;
	function handleRadioRow() {
		/* ak kliknem na hocio, tak tu ulom informciu o tej udalosti do t premennej */
		var t = event.target;	
		/* ak je nzov tagu INPUT, tak nesprav ni, a vrti sa */
		if (t.tagName.toUpperCase() == "INPUT") 
			return;
		/* pokia je nzov tagu rzny od TR, tak iba ulo do t objekt HTMLTablerowelement */
		while (t.tagName.toUpperCase() != "TR") { 
		t = t.parentElement;
		/* vype toto : object HTMLTableRowElement */
		/* alert(t); */
		/* vype slo riadku napr. 10 , zana nulou ! ale tu zapota aj header */ 
		/* alert(t.rowIndex); */
		}
		/* vype slo riadku, ale hlavika m 2 riadky, zana 0, teda riadok 3 bude ako 4*/		
		/* alert(t.rowIndex); */
		/* tu vyhad element ktor m input aby ho mohol nastavi do stavu click */
		var r = t.getElementsByTagName("input")[0];	
		/* vype toto : object HTMLInputElement */		
		/* alert(r); */		
		/* vyzna radio do stavu true */
		r.click();	
		/* zistenie sla vybranho riadku ale s pravou pre odpotanie hlaviky 2 riadkovej ale zana 0 teda -1 */
		vybriadok=t.rowIndex-1;
		/* alert("Klikol si na riadok . "+vybriadok);	*/
		vybku=document.getElementById("my-table-id").rows[vybriadok].cells[2].innerHTML;
		alert("Vybral si kat.zemie . "+vybku);	
    }
</script>

<!-- toto prklad z http://jsfiddle.net/Xp54u/3/  tie nefunguje ale samostatne v htm funguje !!!  -->
<!-- pozn. ku t.rows : rows collection - https://developer.mozilla.org/en-US/docs/Web/API/HTMLTableElement -->
<!-- pozn. ku this.cells : cells collection -->
<!-- funkcia super u po oprave chb poda debuggera funguje ale nejde radio ak oznaujem riadky tak sksim blokn -->
<!-- 2.FUNGUJE iba treba doriei aby dokzal aj oznaova radio ak kliknem hocikde na riadok toto neskr v podstate nepotrebujem v browseri -->
<!--
<script type="text/javascript">
(function () {
    if (window.addEventListener) {
        window.addEventListener("load", run, false);
		} else if (window.attachEvent) {
        window.attachEvent("onload", run);
		}
    function run() {
	var t = document.getElementById("my-table-id");
	var rows = t.rows; 
	for (var i=0; i<rows.length; i++) {
		rows[i].onclick = function (event) {
			if (this.parentNode.nodeName == "THEAD") {
				return;
			}
			var cells = this.cells; 
			var f1 = document.getElementById("radio2");
			var f2 = document.getElementById("okres");
			var f3 = document.getElementById("cisku");
			var f4 = document.getElementById("vymera");
			var f5 = document.getElementById("nazov");
			f1.value = cells[0].innerHTML;
			f2.value = cells[1].innerHTML;
			f3.value = cells[2].innerHTML;
			f4.value = cells[3].innerHTML;
			f5.value = cells[5].innerHTML;
			}
		}	
    }
})();
</script>
-->


<!-- skript pre vyfarbovanie riadkov ke po nich prechdzam mykou, funguje OK -->
<!-- cyklus najprv vymae zakadm vyfarbenie vetkch riadkov a potom ozna farebne iba ten na ktorom je my -->
<!-- BLOKUJEM, LEBO TOTO RIEI STYLE HOVER -->
<!-- 
<script type="text/javascript">
function setrow(row) {
	for (i=1; i<26; i++) {
		var elem = 'r' + i;
		document.getElementById(elem).style.background = "#fff";
	}
	document.getElementById(row).style.background = "#aaa";
	return true;
}
</script>
-->

<!-- skript pre zobrazenie radio buttonov a ich ovldania, tj. zaklikvania, funguje OK -->
<!-- vracia hodnotu bu radioCollection[j].value alebo false  -->
<!-- BLOKUJEM, LEBO ASI NIE JE POTREBN, ZABEZPEUJE U IN FUNKCIA ale asi pre testovacie tlatka sa pouvala ale necha na vzor -->
<!--
<script type="text/javascript">
    function radioValue(radioCollection) {
       for (var j = radioCollection.length - 1; j >= 0; j--) {
        if (radioCollection[j].checked) {
          return radioCollection[j].value;
        }
      }
      return false;
    }    
</script>
-->

<!--skript pre zistenie hodnoty kliknutho riadku resp. jeho porad.indexu, dvam -1 lebo zapotava aj header-->
<!-- BLOKUJEM, IBA NA TESTOVANIE SA POUVALA, ale necha na vzor  -->
<!--
<script type="text/javascript">
    function myFunction(x) {
	px=x.rowIndex-1;
	px2=radioValue(document.getElementsByName('rctrl'));
	alert("myFunction Klikol si na riadok : "+px+", CISKU="+px2);
	return px;
      }
</script>
-->

<!--
<script type="text/javascript">
    function zistiriadok(x) {
	px=x.rowIndex-1;
	alert("zistiriadok - Klikol si na riadok : "+px);
	return px;
      }
</script>
-->

<!--
<script type="text/javascript">
    function zistiku() {
	var vybraneku=document.getElementsById("CISKU");
	alert("zistiku() Vybral si k.. : "+"CISKU="+vybraneku);
	return ;
      }
</script>
-->

ENDTEXT
************************************************************************************************

********************************************************************************************************
* koniec vygenerovanej strnky, alej u nasleduj daje , ako hlavika pol a polia a alie ovldanie
********************************************************************************************************

/* toto vyfarbuje polka v tabuke ak prechdzam mykou
<style>
table td:hover { background-color: red; }
</style>
*/
/* toto vyfarbuje cel riadok ale na ierno
<style>
table tr:hover td {background:#000}
</style>
*/
/* toto vyfarbuje na oranovo, tj. u celkom OK
<style>
table tr:hover td {background:#EDB01C}
</style>
*/
/* toto je u ok, aj psmo sa zmenilo na biele ak oznen ak dm color 191970 tak tmavomodr
<style>
table tr:hover td {background:#EDB01C;color:#FFF}
</style>
*/

*qqq1
* tu by som potreboval zisti, o zadal klient, tj. OKRES,CISKU,...
* ale daje s kde na serveri i kde ??? tu je zklad toho, omu nerozumiem, o tu poui i cargo i var

*qqq3 toto iba pokus omyl ale toto nefunguje
*pomtr:=oClient:GetVar("TESTRCTRL")
*oClient:SetCargo("TESTRCTRL",pomtr)

*qqq3 !!! tu posielam klientovi v HTML aj cBase64String, tj. zobraz sa mu informcia s dajmi ktor s zisten pre neho

*****************************************************************************************************************************
* ODOSLANIE HTML STRNKY KLIENTOVI - tj. vytvor komplet obsah cez DrawtableGrid , prid javascript fnc...
*****************************************************************************************************************************
* ThreadObject():HTTPResponse:Content := cHtml + DrawTableGrid_Raukn( cBase64String ) + "</body></html>"

*qqq prava aby skripty sa zavolali, spustili a po vytvoren strnky, tj. vkladm na koniec pred /body

  ThreadObject():HTTPResponse:Content := cHtml + DrawTableGrid_Raukn( cBase64String ) + cHtml_javascript +"</body></html>"
*****************************************************************************************************************************

  * teda tu u nepjde, lebo kontrolu asi preber web strnk

   Return

//-----------------------------------------------------------------------------
STATIC FUNCTION DrawTableGrid_Raukn( cBase64String, nMaxRows )
//-----------------------------------------------------------------------------
   Local i, cHtml, cPrev, cNext, n
   Local cTable, xTag, xTopScope, xBotScope, cHeading, aFields, bFilter, nFields, aParam
   Local nRows    := 0
   Local oClient  := ThreadObject()
   Local oURL     := xbURI():New()
   Local nDir     := iif(oClient:GetVar("DIR")==NIL, 1, Val(oClient:GetVar("DIR")))
   Local nFromRec := iif(oClient:GetVar("POS")==NIL, 0, Val(oClient:GetVar("POS")))

Local pocetku:=0

*qqq 8.11.2018 iba pokusne preddefinujem zvolen slo k.u., ale toto mus by univerzlne, take peci browser musm funkciu vyrobi
PUBLIC cCISKU:="000000"

* menm aby som lepie videl sprvanie sa browsera
*  DEFAULT nMaxRows TO 25
   DEFAULT nMaxRows TO 15

  // decode the params from the base64 string
* rozkdovanie cBase64String do poa aParam
   if !Empty( cBase64String )
      aParam := &(xbBase64Decode( cBase64String ))
   endif

  // this would be so much simpler with SQL
* rozdelenie poa do premennch cTable...
   cTable     := aParam[1]	// nzov databzy
   xTag       := aParam[2]	// order
   xTopScope  := aParam[3]	// od zznamu poda aktulneho scope ! tj. orderu
   xBotScope  := aParam[4]	// po zznam  poda aktulneho scope ! tj. orderu
   cHeading   := aParam[5]	// nzov tabuky, tj. titulok
   aFields    := aParam[6]	// zoznam pol
   bFilter    := aParam[7]	// code block filtra dajov
   cName      := aParam[8]	// pokusne som tu poslal NAME

*qqq3 tu pridvam dekdovanie tohto parametru
   cTESTRCTRL := aParam[9]	// pokusne som tu poslal TESTRCTRL

* sksim oetri ak nezadan, nezisten
if empty(cTESTRCTRL)
	cTESTRCTRL:="PRAZDNY"
endif

* otvorenie databzy
   USE (cTable) INDEX (cTable) SHARED NEW
   SET DELETED ON

   if ! Empty(xTag)
      OrdSetFocus(xTag)
   endif

   if xTopScope != NIL
      dbSetScope(SCOPE_TOP, xTopScope)
   endif

   if xBotScope != NIL
      dbSetScope(SCOPE_BOTTOM, xBotScope)
   endif

   if ValType(bFilter) == "B"
      dbSetFilter( bFilter )
   endif

   if Empty(aFields)
      nFields := FCount()
      aFields := Array(nFields)
      for i := 1 to nFields
         aFields[i] := i
      next
   else
      nFields := Len(aFields)
   endif

   oURL:Path("BrowseTable_Raukn('" + cBase64String + "')")
   oURL:SetVar(oClient:Parent:SessionTag, oClient:GetSessionHandle())

/*qqq tu sa pokam zisti SID, o by mal klient ma ? i  a potom ho vytlam 
testSID:=oClient:GetSessionHandle()
testCargo:= oClient:GetCargo()	// toto je cel blok,obsahuje aj viacrozmern polia, take sa ned jednoducho zobrazi
if empty(testSID)
testSID:="SID nezisten"
endif
if empty(testCargo)
testCargo:="GetCargo nezisten"
endif
testCargox:=""
for i=1 to len(testCargo)
	if len(testCargo[i])>1
		for j=1 to len(testCargo[i])
			testCargox+="/"+var2char(testCargo[i,j])
		next
	else
		testCargox+="/"+var2char(testCargo[i])
	endif
next
MsgBox(testCargox)	// tu zobraz obsah carga, tj. UID,24342,NAMESECURITY,3,EXCEPTIONS,CLOCKIN,CLOCKOUT tj. viacrozmern pole
*/

*qqq3 tu sksim da pole, ke ho cez hidden nevie prenies 
*     ale sksim tu parameter zskan, ale to je blud, lebo to je in smer , v cTESTRCTRL
*qqq 7.11.2018 a ete tu sksim iba na pokus doplni zobrazenie hodnt vybranch pol tabuky, vi ku skriptu
cHtml1:="RADIO2:<input type='text' id='radio2'>"+;
	"OKRES:<input type='text' id='okres'>"+;
        "CISKU:<input type='text' id='cisku'><br>"+;
        "VYMERA:<input type='text' id='vymera'>"+;		
        "NAZOV:<input type='text' id='nazov'>"+;
        "TESTRCTRL:<input type='text' id='testrctrl' value="+cTESTRCTRL+"><br>"				

*tu zana zobrazenie tabuky browsera vrtane nastavenia nzvu id , titulku, headers
*qqq 6.11.2018 tu sksim prida id tabuky poda jednho z prkladov ktor vyuva onclick javascript
*  cHtml := "<table width=90% align=center><tr>"

*qqq tu skam prida border, hodnoty 0,1,2,.. s iba varianty ormovania, alej sa d vea rznych parametrov nastavova
*  cHtml := "<table id='my-table-id' width=90% align=center><tr>"
*cHtml := "<table border=2 id='my-table-id' width=90% align=center>"+;	// zkladn nastavenia tabuky
cHtml := "<table border=2 id="+"my-table-id"+" width=90% align=center>"+;	// zkladn nastavenia tabuky
	 +cHtml1+;
	 "<CAPTION>"+cTable+" - Zoznam katastrlnych zem"+"</CAPTION>"+;			// nzov, titulok nad tabukou
	 "<tr>"	
* s kontrolnm zobrazenm sla SID
*cHtml := "<table border=2 id="+"my-table-id"+" width=90% align=center>"+;	// zkladn nastavenia tabuky
*	 +cHtml1+;
*	 "<CAPTION>"+cTable+"Zoznam katastrlnych zem"+" - SID="+testSID+"</CAPTION>"+;			// nzov, titulok nad tabukou
*	 "<tr>"									// u zana prv riadok ale ide najprv hlavika

* zobrazenie hlaviky browsera tj. titulok , nFields zvujem + 1 lebo pridvam radio button
* ale nemus tu by takto, lebo mem ma v CAPTION ako je vyie
   if ! Empty(cHeading)
      cHtml += "<th colspan=" + NTrim(nFields+1) + ">" + cHeading + "<br>&nbsp;</th></tr></tr>"
   endif

*qqq 6.11.2018 tu sksim prida stpec pre vber cez RADIO button ete pred pridanm hlaviiek pol databzy
      cHtml += "<th>" + "Vber" + "</th>"

* zobrazenie hlaviky stpcov tabuky
   // draw column headings
   for i := 1 to nFields
      cHtml += "<th>" + FieldName(aFields[i]) + "</th>"
   next

   * koniec riadku hlaviky 
   cHtml += "</tr>"

****
*qqq 12.11.2018 tu sksim prida tento riadok nzov formulra a spsob sprstupnenia dajov formulra cez post, ale to iba test lebo toto je v Login.htm
*    a tu skam prida akciu ak kliknem pri vbere kat.zemia na tlatko Vybra
*    tj. po odoslan,potvrden tlatkom ktor m submit sa vykon funkcia ktor je v action
****
* iba pomenovanie formulra , vi aj na konci /form , a po potvrden submit volanie funkcie Logout
*cHtml += "<form name='Logout_Raukn_ku'>"	// iba pomenovanie formulra, bez alej akcie
* pomenovanie a po submit volanie action Logout_Raukn_ku
*cHtml += "<form name='Logout_Raukn_ku' method='post' action='Logout_Raukn_ku'>"	// ete by som mohol da aj action ale neviem ako spravi
* pomenovanie a po submit volanie action Logout_Raukn_ku ale in zpis s vodzovkami pospjan reaze
*cHtml += "<form name="+"Logout_Raukn_ku"+" method="+"get"+" action="+"Logout_Raukn_ku"+">"	// ete by som mohol da aj action ale neviem ako spravi
* pomenovanie ale na Browser_ku, zrejme to je jedno, iba ak by som chcel zvoli focus, na vybran poloku input polok ako pri logine



*qqq3 tu skam ukoni inak ako logoutom
*cHtml += "<form name="+"Browser_ku"+" method="+"get"+" action="+"Logout_Raukn_ku"+">"	// ete by som mohol da aj action ale neviem ako spravi
cHtml += "<form name="+"Browser_ku"+" method="+"get"+" action="+"TimeClock_Raukn"+">"	// ete by som mohol da aj action ale neviem ako spravi



* tu skam pre volanie funkcie Logou_Raukn_ku prida aj SID ale bez efektu
*cHtml += "<form name="+"Browser_ku"+" method="+"get"+" action="+"Logout_Raukn_ku?"+"_SID="+testSID+">"

* metda post, ale tto in systm, vi kniha javascript
*cHtml += "<form name="+"Logout_Raukn_ku"+" method="+"post"+" action="+"Logout_Raukn_ku"+">"	// ete by som mohol da aj action ale neviem ako spravi
***

*qqq sid toto neviem i je tu dobre, ale ke to nedm, tak v alej funkcii neviem zistit cargo
* pridvam SID definovanie ??? to o je toto ? treba to tu i nie tu musm cez strtran nahradi skutonm SIDom
cHtml += "<input type=hidden name="+"_SID"+" value="+"<%sid%>"+">"

*cHtml += "<input type=hidden name="+"RCTRLTEST"+" value="+"ABC"+">"
*cHtml += "<input type=hidden name="+"CLOCKIN"+" value="+"ABC"+">"


*qqq3 tu skam prenies hodnotu pri skonen submitom tlatko dole, tj. vber k.u. a nie hore odhlsenie
cHtml += "<input type=hidden name="+"TESTRCTRL"+" value="+"ABC"+">"


* toto je nejak oetrenie na zznamy, tj. i m skoi na zaiatok alebo od uritho riadku 
   if nFromRec == 0
      dbGoTop()
   else
      dbGoTo(nFromRec)
      if nDir < 0
         // skip back nMaxRows
         dbSkip(-nMaxRows)
      endif
      // skip back to see if we're at the top
      // no sense of displaying "Prev Page" link if we're already at the top
      dbSkip(-1)
      if !Bof()
         dbSkip()
         oURL:SetVar("DIR", "-1")
         oURL:SetVar("POS", NTrim(RecNo()))
         cPrev := oURL:AsString()
      endif
   endif

* vpis riadkov tabuky	
   // draw the table contents
   n := 0	// vynulovanie potadla riadkov

*zistenie potu zatia iba pokusne takto cez count
count to pocetku
go top

* cyklus pre vpis vetkch riadkov tabuky ale iba pre nMaxRows
****************************************************************
do while !Eof() .and. ++nRows <= nMaxRows

	* tu uloenie sla k.u. a nzvu , potom toto ulom ku radiobuttonu zatia testujem
	pomcisku:=alltrim(str(CISKU))
	pomnazov:=alltrim(NAZOV)
	criadok:=alltrim(str(n))	// prava pre pouitie ako id pri oznaen radio buttonu

	* tu neviem nao vyhodnocuje modulo aj preo je class r0 alebo r1 rozdielny, neskr zisti
	* ak prny poet riadkov
	if (++n % 2) == 0

		* u tu musm doplni ak chcem nieo ohadom ovldania riadku lebo kon s > a alej ide td
        	*cHtml += "<tr class=r0>"	// neviem o to rob, class r0 r1 asi iba pomenujem 
		* tu sksim doplni ale u tu pre table row onclick pre zistenie i som ten riadok klikol vola myFunction javascript
*qqq 8.11.2018 tu zablokujem aby mi nevyhadzovalo oznamy ke chcem spravi aby reagoval na spodn tlatko
*		cHtml +="<tr class=r0 onclick='myFunction(this)'>"	

*qqq 9.11.2018 skam funkciu handleRadioRow, i ozna radio ak kliknem na riadok  - FUNGUJE !!!
*        	cHtml += "<tr class=r0>"
        	cHtml += "<tr class=r0 onclick='handleRadioRow()' style='cursor': pointer;>"

	* ak neprny poet riadkov
	else

		* u tu musm doplni ak chcem nieo ohadom ovldania riadku lebo kon s > a alej ide td
        	*cHtml += "<tr class=r1>"
		* tu sksim doplni ale u tu pre table row onclick pre zistenie i som ten riadok klikol vola myFunction javascript
		* pridvam funkciu pre onclic myFunction a odovzdvam jej this hodnotu, to je selected riadok
*qqq 8.11.2018 tu zablokujem aby mi nevyhadzovalo oznamy ke chcem spravi aby reagoval na spodn tlatko 
*		cHtml +="<tr class=r1 onclick='myFunction(this)'>"	

*qqq 9.11.2018 skam funkciu handleRadioRow, i ozna radio ak kliknem na riadok  - FUNGUJE !!!
*        	cHtml += "<tr class=r1>"
        	cHtml += "<tr class=r1 onclick='handleRadioRow()' style='cursor': pointer;>"

	endif

	* cyklus pre zobrazenie polok vetkch stpcov, i je slo stpca		
	********************************************************************
	for i := 1 to nFields

		* tu sksim upravi, doplni radio button, preto vyhodnocujem, i je to prv radio stpec alebo dtov stpce
		* pvodn
		* cHtml += "<td>" + Var2Char(FieldGet( aFields[i] )) + "</td>"

		* iba pre prv pole zobraz button radio, a ostatn nie, ale zatia neviem, ako sa d poui vybran hodnota, 	
		*****************************************
		* onclick zabezpe e ke kliknem , tak sa aktivuje
		* pozor, ak vynechm name=rctrl, tak potom neodznauje radioboxy, take mus by
		if i=1

			*qqq 8.11.2018 tu sksim prida value= teraz u po kliknut dole tlatka Vybran kat.zemie zobraz jeho slo a nzov
			* toto funguje dobre na radio button, ale iba ak kliknem na pole kde je radio a len na gulicku radio
			* tu ete s onclick, spsobovalo zobrazenie setrow a zobrazenie alert okienka, ale toto vyradzujem

			* hadm sprvny syntax ale toto nejak nefunguje ako chcem lebo asi vyrarbovanie riadkov pri mouseover rob in funkcia resp. style
			 *cHtml += "<td><input type='radio' name='rctrl' value= "+pomcisku+"-"+pomnazov+" onclick='return setrow('r1')'></td>"
			 *cHtml += "<td><input type='radio' name='rctrl' value= "+pomcisku+"-"+pomnazov+" onclick="+"return setrow('r1')"+"></td>"
			 *cHtml += "<td><input type='radio' name='rctrl' value= "+pomcisku+"-"+pomnazov+" onclick="+"setrow('r1')"+"></td>"

* !!! tu by som asi nemal dva hodnotu value, lebo radio ma by true,false ?
			* toto reaguje na kliknutie buttonu radio
		 	cHtml += "<td><input type='radio' name='rctrl' value= "+pomcisku+"-"+pomnazov+"></td>"
*qqq pozor !!! tu ukka ak dm aj id=radio tak dovol zaklikn viac buttonov, o ja nechcem
*		 	cHtml += "<td><input type='radio' id='radio1' value= "+pomcisku+"-"+pomnazov+"></td>"

			* toto som skobne pridal hidden tj. ako al prvok, ktor nevidno, ale mal by reagova na kliknutie len treba
			* nejak upravi funkciu v js, aby nebolo radio ale prvok tabulky typu text, events ?
			*cHtml += "<td><input type='radio' name='rctrl' value= "+pomcisku+"-"+pomnazov+"><input type='hidden' name='rctrl2' value= "+pomcisku+"-"+pomnazov+"></td>"

			* a tu prava doplnen slo riadku a malo by to reagova na kliknutie aj na text pri radio buttone u funguje dobre
		 	*cHtml += "<td><input type='radio' id="+"rbox"+criadok+" name='rctrl' value="+pomcisku+"-"+pomnazov+"><label for="+"rbox"+criadok+">Vber"+criadok+"</label></td>"
			* a ete zrum label resp. mem necha label poda poradovho sla v databze napr. poda recno() !!! teraz dm przdny bodky
			* lebo ak nedm ni tak nereaguje, mus tam by nejak text alebo by som musel da ete hidden
		 	*cHtml += "<td><input type='radio' id="+"rbox"+criadok+" name='rctrl' value="+pomcisku+"-"+pomnazov+"><label for="+"rbox"+criadok+">"+".........."+"</label></td>"
			* plus sksim da hidden 	
		 	*cHtml += "<td><input type='radio' id="+"rbox"+criadok+" name='rctrl' value="+pomcisku+"-"+pomnazov+">"+;
			*	      "<input type='hidden' id="+"rbox"+criadok+" name='rctrl' value= "+pomcisku+"-"+pomnazov+"><label for="+"rbox"+criadok+">"+".........."+"</label></td>"
			* tu v spojen s spanclass ktor je funkcia vyie nezobraz radio ale povol kliknutie na polko, ktor ostane vyfarben a funguje ako button radio ale zase iba s textom ? neviem preo
		 	*cHtml += "<td><input type='radio' id="+"rbox"+criadok+" name='rctrl' value="+pomcisku+"-"+pomnazov+">"+;
			*	      "<input type='hidden' id="+"rbox"+criadok+" name='rctrl' value= "+pomcisku+"-"+pomnazov+"><label for="+"rbox"+criadok+"><span class='sc-tooltip'>Tabbable</span></label></td>"

		endif

		* tu u zobraz iba samotn obsah poa
		**************************************

		* povodn zpis  zobraz obsah poa databzy
		* tu by som mohol sksi da aj value pre jednotliv polia uloi, aby som nemusel uklada, napr. doplni zatia neviem ako

		cHtml += "<td>" + Var2Char(FieldGet( aFields[i] )) + "</td>"

		* tu iba pokusy, ale nedorieil som aby reagovalo na cel riadok
		* sksim rovnako ako pri radio doplni pre riadok hodnoty pomcisku a pomnazov lebo pri kliknuti na riadok neaktualizuje v okienku alert
		* ale nefunguje to , skam hidden tj. schovva value 
		* cHtml += "<td>"+"<input type='radio' name='rctrl2' value= "+pomcisku+"-"+pomnazov+" onclick='return 'myFunction(this)' >" + Var2Char(FieldGet( aFields[i] )) + "</td>"

		* najprv iba takto
		* cHtml += "<td>" +"<value="+"999"+">"+ Var2Char(FieldGet( aFields[i] )) + "</td>"
		* potom tu u ulom hodnotu poa 2 o je CISKU ale toto je zloit, lebo musm browser urobi univerzlne
		* tu sksim fixne da poradie 2 CISKU
		*  cHtml += "<td>" +"<value="+Var2Char(FieldGet( aFields[2] ))+">"+ Var2Char(FieldGet( aFields[i] )) + "</td>"

      next

      cHtml += "</tr>"	// znaka konca riadku tabuky html

      dbSkip()		// skok na al zznam tabuky v dbf
enddo

* toto neviem presne o rob ale asi kontroluje EOF, a ak vychdza na strnku koniec sboru tak asi inak zobraz
   if !Eof()
      // add page down link only if we're not at EOF
      oURL:SetVar("DIR", "1")
      oURL:SetVar("POS", NTrim(RecNo()))
      cNext := oURL:AsString()
   endif

* toto je pridanie tlatok Prev page, Next page na spodok tabuky
   // add hyperlinks for page up/down

/* sksim tam prida svoje tlatko
   cHtml += "<tr><th colspan=" + NTrim(nFields) +" style='text-align:right;'><br>" +;
            iif(cPrev==Nil, "<font style=color:gray;>Prev Page</font>", "<a href=" + cPrev + ">Prev Page</a>") + ;
            " | " +;
            iif(cNext==Nil, "<font style=color:gray;>Next Page</font>", "<a href=" + cNext + ">Next Page</a>") +;
            "</th></tr>" +;
            "</table>"
*/
* tu iba zadefinujem, pozri ako cPrev,cNext je ako URL vytvoren a pridvam svoje tlatka Vber a Storno
cVyber=""	// pri 1!=1 sa zobraz Vber2, ale toto je iba pokusne
cStorno=""
   cHtml += "<tr><th colspan=" + NTrim(nFields) +" style='text-align:left;'><br>" +;
            iif(1!=1, "<font style=color:gray;>Vber1</font>", "<a href=" + cVyber + ">Vber2</a>") + ;	// ukka ako zaeden/povolen tlatko
            " | " +;
            iif(1!=1, "<font style=color:gray;>Storno</font>", "<a href=" + cStorno + ">Storno</a>") +;
            "</th>" +;
	    "<th colspan=" + NTrim(nFields) +" style='text-align:right;'>" +;
            iif(cPrev==Nil, "<font style=color:gray;>Prev Page</font>", "<a href=" + cPrev + ">Prev Page</a>") + ;	// ukka zobrazenia tlatok predch.strana/nasledujca strana s oetrenm, kedy ktor povoli poda EOF,BOF
            " | " +;
            iif(cNext==Nil, "<font style=color:gray;>Next Page</font>", "<a href=" + cNext + ">Next Page</a>") +;
            "</th></tr>" +;
		"<br><tr><th>" + "Poet k.. : " + alltrim(str(pocetku)) + "<tr></th>" +;
            "</table>" +;
	    "<p>" +;
	    "    <button onclick="+"zistiriadok(this)"+">" +;
	    "Zistiriadok(this)" +;
	    "    </button>" +;
	    "</p>"+;
	    "<p>" +;
	    "    <button onclick="+"zistiku()"+">" +;
	    "Zistiku(this)" +;
	    "    </button>" +;
	    "</p>"+;
	    "<tr><td class='footer' colspan=2 ><input type='submit' value='Vybra k.u. - Submit1'></td></tr>"+;	// toto je tlako typu Submit, po potvrden vykon action !
	    "</form>"			// koniec bloku formulra logout_raukn_ku

*qqq 30.11.2018 tu vyie pridvam u hidden premenn a vkladm do nej value vybku i sa dao udeje

	dbCLoseAll()	// zatvorenie databz, toto sa vykon ete pred zobrazenm browsera v HTML tabuke

* pozor, tu je ete v bloku cHtml, take tu nedva ni na vykonanie, inak sa to vykon pred samotnm zobrazenm browsera v html

* a tu nahrdzam %sid hodnotou
cHtml := StrTran(cHtml, "<%sid%>"   , ThreadObject():GetSessionHandle(), 1, 1)


*qqq 30.11.2018 skmanie ako funguje posielanie premennch od klienta na server - tu sa pole alej ale toto nie je sprvne
*******************************************************************************
*pomvybku:="999999"			// najpr pokusne zadefinujem hodnotu premennej	
*oClient:SetCargo("RCTRLTEST",pomvybku)	// skam posla na server - funguje, objav sa alej
*oClient:SetCargo("CLOCKOUT",pomvybku)	// skam posla na server - funguje, objav sa alej

* ale vyie ako mm input type ... RCTRLTEST aj CLOCKOUT ani toto sa neprenesie, teda neviem ako funguje
* musm si zakresli trasu klient, server request, response
* asi tu to neme by lebo tu sa len generuje cHtml to inak musm riei

Return cHtml

//----------------------------------------------------------------------------------------------------
STATIC FUNCTION LockRecord()
   Local i := 0

   for i := 1 to 10   // try for a max 5 sec
      if dbRLock()
         return .t.
      endif
      sleep( 50 )
   next

   dbCLoseAll()
   Break( "Unable to obtain record lock!" )  // unable to lock record -- this will cause an error to be returned to the client
   Return .f.

* toto je u zkladn horn menu funkci, hlavika , menu
//-----------------------------------------------------------------------------
WEBPROC Header_Raukn() PATH TC
//-----------------------------------------------------------------------------
   GETCARGO SECURITY AS nSecurity

   Static cTemplate
   Local cSID := oClient:GetSessionHandle()
   Local cLinks

   CHECKLOGIN	// toto iba skontroluje i je uvate prihlsen funkciou isLoggedIn_Raukn() a ak nie, ponkne prihlasovacie okno

   if Empty(nSecurity)
      oClient:SendFile( oClient:Parent:RootDir + "\TC\Login_Raukn.htm" )
      Return
   endif

   debug( "TC_Header: SID", oClient:GetSessionHandle(), "# Sess", xbSession():ActiveSessions(), "CARGO", oClient:GetCargo())

   if cTemplate == NIL
      TEXT INTO cTemplate TRIMMED
      <html>
      <head>
       <title>TimeClock*</title>
       <link rel="stylesheet" media="screen" type="text/css" href="/style.css">
       <style type="text/css">
       body {margin:0; background-color: yellow;}
       a.cold {text-decoration:none; color: navy;}
       a:visited {text-decoration:none; color: navy;}
       a.cold:hover {text-decoration:underline; color:red;}
       table {cell-padding:0;margin-top:0;padding:0;}
       td		{background-color: yellow; vertical-align:center;}
       td.link {padding-left:8; font-weight:bold; text-decoration:none; font-family:verdana,arial;}
       td.name {text-align:right; padding-left:5; padding-top:4; font-weight:bold; text-decoration:none; color:black; font-family:verdana,arial;}
       </style>
       </head>
      <body>

      <table width=99%>
        <tr>
         <td>
            <table width=680px>
              <tr>
              <%links%>
              </tr>
            </table>
         </td>
         <td class=name>Velektronic&nbsp;&nbsp;Company</td>
        </tr>
      </table>

      </body>
      </html>
      ENDTEXT
   endif

*qqq POZOR , table width 380px bolo mlo, treba pre viac poloiek menu irie, potrebn prepota na rku menu a poda fontu
* neviem kde sa nastavuje vekos fontu

* tu u sa pri vbere funkcie z hornho menu volaj alie funkcie

* ponuka funkci v hornom menu, tj. v Header 
********************************************
   cLinks := HeaderLink_Raukn( "DOCHDZKA;IN/OUT", "TimeClock_Raukn", cSID )

   * zobrazenie poloky menu iba ak je admin
   if nSecurity >= SEC_ADMIN
      cLinks += HeaderLink_Raukn( "REPORT", "Reports", cSID )
   endif

   cLinks += HeaderLink_Raukn( "POMOC"      , "UnderConstruction_Raukn('HELP')", cSID )

   cLinks += HeaderLink_Raukn( "SKڊKA"     , "UnderConstruction_Raukn('HELP')", cSID )

   cLinks += HeaderLink_Raukn( "ODHLSENIE" , "Logout_Raukn", cSID )

* odoslanie vytvorenej ponuky klientovi
   oClient:HTTPResponse:Content := StrTran(cTemplate, "<%links%>", cLinks, 1, 1)

   Return

* toto je pomocn funkcia, ktor vygeneruje html kd poda volania funkci vyie s parametrami 
//----------------------------------------------------------------------------------------------
STATIC FUNCTION HeaderLink_Raukn( cDisplay, cFunction, cSID )
//----------------------------------------------------------------------------------------------
   Return '<td class=link><img src=/4dot.gif> <a href=' + cFunction +;
          '?_SID=' + cSID + ' class="cold" title="' + cDisplay +;
          '" target=main>' + cDisplay + '</a></td>'


//-----------------------------------------------------------------------------
WEBPROC UnderConstruction_Raukn( cName ) PATH TC
   CHECKLOGIN
   DEFAULT cName TO "Tto"
   FlashError( cName + " funkcia ete nie je implementovan...", "TimeClock_Raukn?_SID=" + ThreadObject():GetSessionHandle() )
   Return

**********************************
FUNCTION LAT_IBM(ptext)        // Funkcia pre odstranenie diakritiky z textu v LATIN-2
**********************************         // funkcne identicka s LAT_IBM z FoxPro CS Lib
* pvodn verzia pre DOS Latin 2 - CP852
*****************************************************
* potrebn pre dulne porovnvanie oboch kdovch strnok

LOCAL outriadok:="",pocet:=0,i:=0,znak:=0

pocet:=len(ptext)                && zistenie poctu znakov v riadku

* cyklus pre nacitavanie znakov a konvertovany zapis do vystupu
for i=1 to pocet

                znak:=asc(ptext[i])

*qqq prava pre obmedzenie konverzie iba pre znaky s diakritikou
if znak>127 .or. znak=42 .or. znak=63
                DO CASE
                CASE znak==128
                        znak:=67
                CASE znak==129
                        znak:=117
                CASE znak==130
                        znak:=101
                CASE znak==131
                        znak:=97
                CASE znak==132
                        znak:=97
                CASE znak==133
                        znak:=117
                CASE znak==134
                        znak:=99
                CASE znak==135
                        znak:=99
                CASE znak==136
                        znak:=108
                CASE znak==137
                        znak:=101
                CASE znak==138
                        znak:=79
                CASE znak==139
                        znak:=111
                CASE znak==140
                        znak:=105
                CASE znak==141
                        znak:=90
                CASE znak==142
                        znak:=65
                CASE znak==143
                        znak:=67
                CASE znak==144
                        znak:=69
                CASE znak==145
                        znak:=76
                CASE znak==146
                        znak:=108
                CASE znak==147
                        znak:=111
                CASE znak==148
                        znak:=111
                CASE znak==149
                        znak:=76
                CASE znak==150
                        znak:=108
                CASE znak==151
                        znak:=83
                CASE znak==152
                        znak:=115
                CASE znak==153
                        znak:=79
                CASE znak==154
                        znak:=85
                CASE znak==155
                        znak:=84
                CASE znak==156
                        znak:=116
                CASE znak==157
                        znak:=76
                CASE znak==158
                        znak:=120
                CASE znak==159
                        znak:=99
                CASE znak==160
                        znak:=97
                CASE znak==161
                        znak:=105
                CASE znak==162
                        znak:=111
                CASE znak==163
                        znak:=117
                CASE znak==164
                        znak:=65
                CASE znak==165
                        znak:=97
                CASE znak==166
                        znak:=90
                CASE znak==167
                        znak:=122
                CASE znak==168
                        znak:=69
                CASE znak==169
                        znak:=101
                CASE znak==170
                        znak:=32
                CASE znak==171
                        znak:=122
                CASE znak==172
                        znak:=67
                CASE znak==173
                        znak:=115
                CASE znak==181
                        znak:=65
                CASE znak==182
                        znak:=65
                CASE znak==183
                        znak:=69
                CASE znak==184
                        znak:=83
                CASE znak==189
                        znak:=90
                CASE znak==190
                        znak:=122
                CASE znak==198
                        znak:=65
                CASE znak==199
                        znak:=97
                CASE znak==207
                        znak:=46
                CASE znak==208
                        znak:=100
                CASE znak==209
                        znak:=68
                CASE znak==210
                        znak:=68
                CASE znak==211
                        znak:=69
                CASE znak==212
                        znak:=100
                CASE znak==213
                        znak:=78
                CASE znak==214
                        znak:=73
                CASE znak==215
                        znak:=73
                CASE znak==216
                        znak:=101
                CASE znak==221
                        znak:=84
                CASE znak==222
                        znak:=85
                CASE znak==224
                        znak:=79
                CASE znak==226
                        znak:=79
                CASE znak==227
                        znak:=78
                CASE znak==228
                        znak:=110
                CASE znak==229
                        znak:=110
                CASE znak==230
                        znak:=83
                CASE znak==231
                        znak:=115
                CASE znak==232
                        znak:=82
                CASE znak==233
                        znak:=85
                CASE znak==234
                        znak:=114
                CASE znak==235
                        znak:=85
                CASE znak==236
                        znak:=121
                CASE znak==237
                        znak:=89
                CASE znak==238
                        znak:=116
                CASE znak==239
                        znak:=46
                CASE znak==240
                        znak:=46
                CASE znak==241
                        znak:=46
                CASE znak==242
                        znak:=46
                CASE znak==243
                        znak:=46
                CASE znak==244
                        znak:=46
                CASE znak==245
                        znak:=173
                CASE znak==247
                        znak:=46
                CASE znak==248
                        znak:=46
                CASE znak==249
                        znak:=46
                CASE znak==251
                        znak:=117
                CASE znak==252
                        znak:=82
                CASE znak==253
                        znak:=114
                * doplnenie spracovania aj wildcard pre hladtext iba
                ** hviezdika *
                CASE znak==42
                        znak:=42
                ** otznik ?
                CASE znak==63
                        znak:=63
                ENDCASE
endif
                outriadok+=chr(znak)
next

RETURN outriadok

*optim3 - prava pre optimalizovan verziu lat_ibm
**********************************
FUNCTION LAT_IBM_O(ptext)        // Funkcia pre odstranenie diakritiky z textu v LATIN-2	- optimalizovan z array
**********************************         // funkcne identicka s LAT_IBM z FoxPro CS Lib
* pvodn verzia pre DOS Latin 2 - CP852
*****************************************************
* potrebn pre dulne porovnvanie oboch kdovch strnok

LOCAL outriadok:="",pocet:=0,i:=0,znak:=0
LOCAL znaku:=0

* znaka[] zadefinovan v DEFINUJ_LAT_IBM_O 

pocet:=len(ptext)                && zistenie poctu znakov v riadku

* cyklus pre nacitavanie znakov a konvertovany zapis do vystupu
for i=1 to pocet

	znak:=asc(ptext[i])

	*qqq prava pre obmedzenie konverzie iba pre znaky s diakritikou
	if znak>127

*qqq 15.6.2018 prava, optimalizcia
*		znaku:=znaka[znak]
                outriadok+=chr(znaka[znak])

	** hviezdika *
	elseif znak=42

*qqq 15.6.2018 prava, optimalizcia
*		znaku:=42
                outriadok+=chr(42)

        ** otznik ?
	elseif znak=63 

*qqq 15.6.2018 prava, optimalizcia
*		znaku:=63
                outriadok+=chr(63)
	else

*qqq 15.6.2018 prava, optimalizcia
*		znaku:=znak
                outriadok+=chr(znak)

	endif

*qqq 15.6.2018 prava, optimalizcia
*                outriadok+=chr(znaku)

next

RETURN outriadok

***************************************
FUNCTION LAT_IBM_U(ptext)                 // Funkcia pre odstranenie diakritiky z textu v LATIN-2
***************************************
* upraven pre Windows CE,EE CP1250
**************************************************
* Prekdovanie je poda tabuku Windows CE, EE CP1250 do kdov bez diakritiky
* zkladn ASCII ktor je spolon pre vetky kdov strnky od chr 0 do 127

LOCAL outriadok:=space(0),pocet:=0,i:=0,znak:=0

pocet:=len(ptext)                && zistenie poctu znakov v riadku

* cyklus pre nacitavanie znakov a konvertovany zapis do vystupu
for i=1 to pocet
                znak:=asc(ptext[i])

                * prekduje znaky s diakritikou do kdov bez
                * ostatn nevyuit kdy nech tak
*qqq prava pre obmedzenie konverzie iba pre znaky s diakritikou
if znak>127
                DO CASE
*                CASE znak==128
*                        znak:=67
*                CASE znak==129
*                        znak:=117
*                CASE znak==130
*                        znak:=101
*                CASE znak==131
*                        znak:=97
*                CASE znak==132
*                        znak:=97
*                CASE znak==133
*                        znak:=117
*                CASE znak==134
*                        znak:=99
*                CASE znak==135
*                        znak:=99
*                CASE znak==136
*                        znak:=108
*                CASE znak==137
*                        znak:=101
                * 
                CASE znak==138
                        znak:=83
*                CASE znak==139
*                        znak:=111
*                CASE znak==140
*                        znak:=105
                * 
                CASE znak==141
                        znak:=84
                * 
                CASE znak==142
                        znak:=90
*                CASE znak==143
*                        znak:=67
*                CASE znak==144
*                        znak:=69
*                CASE znak==145
*                        znak:=76
*                CASE znak==146
*                        znak:=108
*                CASE znak==147
*                        znak:=111
*                CASE znak==148
*                        znak:=111
*                CASE znak==149
*                        znak:=76
*                CASE znak==150
*                        znak:=108
*                CASE znak==151
*                        znak:=83
*                CASE znak==152
*                        znak:=115
*                CASE znak==153
*                        znak:=79
                * 
                CASE znak==154
                        znak:=115
*                CASE znak==155
*                        znak:=84
*                CASE znak==156
*                        znak:=116
                * 
                CASE znak==157
                        znak:=116
                * 
                CASE znak==158
                        znak:=122
*                CASE znak==159
*                        znak:=99
*                CASE znak==160
*                        znak:=97
*                CASE znak==161
*                        znak:=105
*                CASE znak==162
*                        znak:=111
*                CASE znak==163
*                        znak:=117
*                CASE znak==164
*                        znak:=65
*                CASE znak==165
*                        znak:=97
*                CASE znak==166
*                        znak:=90
*                CASE znak==167
*                        znak:=122
*                CASE znak==168
*                        znak:=69
*                CASE znak==169
*                        znak:=101
*                CASE znak==170
*                        znak:=32
*                CASE znak==171
*                        znak:=122
*                CASE znak==172
*                        znak:=67
*                CASE znak==173
*                        znak:=115
*                CASE znak==174
*                        znak:=115
*                CASE znak==175
*                        znak:=115
*                CASE znak==176
*                        znak:=115
*                CASE znak==177
*                        znak:=115
*                CASE znak==178
*                        znak:=115
*                CASE znak==179
*                        znak:=115
*                CASE znak==180
*                        znak:=115
*                CASE znak==181
*                        znak:=65
*                CASE znak==182
*                        znak:=65
*                CASE znak==183
*                        znak:=69
*                CASE znak==184
*                        znak:=83
*                CASE znak==185
*                        znak:=83
*                CASE znak==186
*                        znak:=83
*                CASE znak==187
*                        znak:=83
                * 
                CASE znak==188
                        znak:=76
*                CASE znak==189
*                        znak:=90
                * 
                CASE znak==190
                        znak:=108
*                CASE znak==191
*                        znak:=108
                * 
                CASE znak==192
                        znak:=82
                * 
                CASE znak==193
                        znak:=65
*                CASE znak==194
*                        znak:=108
*                CASE znak==195
*                        znak:=108
                * A irok
                CASE znak==196
                        znak:=65
                * 
                CASE znak==197
                        znak:=76
*                CASE znak==198
*                        znak:=65
*                CASE znak==199
*                        znak:=97
                * 
                CASE znak==200
                        znak:=67
                * 
                CASE znak==201
                        znak:=69
*                CASE znak==202
*                        znak:=46
                * E s dvoma bodkami
                CASE znak==203
                        znak:=69
                * 
                CASE znak==204
                        znak:=69
                * 
                CASE znak==205
                        znak:=73
*                CASE znak==206
*                        znak:=46
                * 
                CASE znak==207
                        znak:=68
*                CASE znak==208
*                        znak:=100
*                CASE znak==209
*                        znak:=68
                * 
                CASE znak==210
                        znak:=78
                * 
                CASE znak==211
                        znak:=79
                * O s vkaom
                CASE znak==212
                        znak:=79
                * O s dvoma iarkami
                CASE znak==213
                        znak:=79
                * O s dvoma bodkami
                CASE znak==214
                        znak:=79
*                CASE znak==215
*                        znak:=73
                * 
                CASE znak==216
                        znak:=82
                * U s krkom
                CASE znak==217
                        znak:=85
                * 
                CASE znak==218
                        znak:=85
                * U s dvoma iarkami
                CASE znak==219
                        znak=85
                * U s dvoma bodkami
                CASE znak==220
                        znak:=85
                * 
                CASE znak==221
                        znak:=89
*                CASE znak==222
*                        znak:=85
*                CASE znak==223
*                        znak:=85
                * 
                CASE znak==224
                        znak:=114
                * 
                CASE znak==225
                        znak:=97
*                CASE znak==226
*                        znak:=79
*                CASE znak==227
*                        znak:=78
                * 
                CASE znak==228
                        znak:=97
                * 
                CASE znak==229
                        znak:=108
*                CASE znak==230
*                        znak:=83
*                CASE znak==231
*                        znak:=115
                * 
                CASE znak==232
                        znak:=99
                * 
                CASE znak==233
                        znak=101
*                CASE znak==234
*                        znak:=114
*                CASE znak==235
*                        znak:=85
                * 
                CASE znak==236
                        znak:=101
                * 
                CASE znak==237
                        znak:=105
*                CASE znak==238
*                        znak:=116
                * 
                CASE znak==239
                        znak:=100
*                CASE znak==240
*                        znak:=46
*                CASE znak==241
*                        znak:=46
                * 
                CASE znak==242
                        znak:=110
                * 
                CASE znak==243
                        znak:=111
                * 
                CASE znak==244
                        znak=111
                * o s dvoma iarkami
                CASE znak==245
                        znak:=111
                * o s dvoma bodkami
                CASE znak==246
                        znak:=111
*                CASE znak==247
*                        znak:=46
                * 
                CASE znak==248
                        znak:=114
                * u s krkom
                CASE znak==249
                        znak:=117
                * 
                CASE znak==250
                        znak:=117
                * u s dvoma iarkami
                CASE znak==251
                        znak:=117
                * u s dvoma bodkami
                CASE znak==252
                        znak:=117
                * 
                CASE znak==253
                        znak:=121
*                CASE znak==254
*                        znak:=114
*                CASE znak==255
*                        znak:=114
                ENDCASE
endif
                outriadok+=chr(znak)
next

RETURN outriadok

*qqq optim3
***************************************
FUNCTION LAT_IBM_U_O(ptext)                 // Funkcia pre odstranenie diakritiky z textu v LATIN-2	- optimalizovan z array
***************************************
* upraven pre Windows CE,EE CP1250
**************************************************
* Prekdovanie je poda tabuku Windows CE, EE CP1250 do kdov bez diakritiky
* zkladn ASCII ktor je spolon pre vetky kdov strnky od chr 0 do 127

LOCAL outriadok:=space(0),pocet:=0,i:=0,znak:=0
LOCAL znakuu:=0

* znakau[] zadefinovan v DEFINUJ_LAT_IBM_U_O 

pocet:=len(ptext)                && zistenie poctu znakov v riadku

*if pocet!=0		// doplnkov kontrola na przdny text

* cyklus pre nacitavanie znakov a konvertovany zapis do vystupu
for i=1 to pocet

	znak:=asc(ptext[i])

	*qqq prava pre obmedzenie konverzie iba pre znaky s diakritikou
	if znak>127

*qqq 15.6.2018 prava
*		znakuu:=znakau[znak]
*	        outriadok+=chr(znakuu)		// tu presvam odlin spracovanie znakov >127

		outriadok+=chr(znakau[znak])	

	else


*qqq 15.6.2018 prava
*		znakuu:=znak
*	        outriadok+=ptext[i]		// tu presvam odlin spracovanie znakov <=127

		outriadok+=ptext[i]

	endif

*        outriadok+=chr(znakuu)			// tu blokujem a presvam odlin spracovanie znakov vyie
next

*endif

RETURN outriadok

***************************
FUNCTION DEFINUJ_LAT_IBM_O		// konverzn pole pre LAT_IBM_O CP822 na IBM
***************************
PUBLIC znaka[255]

*definovanie array znakov pozor vetky musm
znaka[128]:=67
znaka[129]:=117
znaka[130]:=101
znaka[131]:=97
znaka[132]:=97
znaka[133]:=117
znaka[134]:=99
znaka[135]:=99
znaka[136]:=108
znaka[137]:=101
znaka[138]:=79
znaka[139]:=111
znaka[140]:=105
znaka[141]:=90
znaka[142]:=65
znaka[143]:=67
znaka[144]:=69
znaka[145]:=76
znaka[146]:=108
znaka[147]:=111
znaka[148]:=111
znaka[149]:=76
znaka[150]:=108
znaka[151]:=83
znaka[152]:=115
znaka[153]:=79
znaka[154]:=85
znaka[155]:=84
znaka[156]:=116
znaka[157]:=76
znaka[158]:=120
znaka[159]:=99
znaka[160]:=97
znaka[161]:=105
znaka[162]:=111
znaka[163]:=117
znaka[164]:=65
znaka[165]:=97
znaka[166]:=90
znaka[167]:=122
znaka[168]:=69
znaka[169]:=101
znaka[170]:=32
znaka[171]:=122
znaka[172]:=67
znaka[173]:=115
znaka[174]:=174
znaka[175]:=175
znaka[176]:=176
znaka[177]:=177
znaka[178]:=178
znaka[179]:=179
znaka[180]:=180
znaka[181]:=65
znaka[182]:=65
znaka[183]:=69
znaka[184]:=83
znaka[185]:=185
znaka[186]:=186
znaka[187]:=187
znaka[188]:=188
znaka[189]:=90
znaka[190]:=122
znaka[191]:=191
znaka[192]:=192
znaka[193]:=193
znaka[194]:=194
znaka[195]:=195
znaka[196]:=196
znaka[197]:=197
znaka[198]:=65
znaka[199]:=97
znaka[200]:=200
znaka[201]:=201
znaka[202]:=202
znaka[203]:=203
znaka[204]:=204
znaka[205]:=205
znaka[206]:=206
znaka[207]:=46
znaka[208]:=100
znaka[209]:=68
znaka[210]:=68
znaka[211]:=69
znaka[212]:=100
znaka[213]:=78
znaka[214]:=73
znaka[215]:=73
znaka[216]:=101
znaka[217]:=217
znaka[218]:=218
znaka[219]:=219
znaka[220]:=220
znaka[221]:=84
znaka[222]:=85
znaka[223]:=223
znaka[224]:=79
znaka[225]:=225
znaka[226]:=79
znaka[227]:=78
znaka[228]:=110
znaka[229]:=110
znaka[230]:=83
znaka[231]:=115
znaka[232]:=82
znaka[233]:=85
znaka[234]:=114
znaka[235]:=85
znaka[236]:=121
znaka[237]:=89
znaka[238]:=116
znaka[239]:=46
znaka[240]:=46
znaka[241]:=46
znaka[242]:=46
znaka[243]:=46
znaka[244]:=46
znaka[245]:=173
znaka[246]:=246
znaka[247]:=46
znaka[248]:=46
znaka[249]:=46
znaka[250]:=250
znaka[251]:=117
znaka[252]:=82
znaka[253]:=114
znaka[254]:=254
znaka[255]:=255
Return nil

*****************************
FUNCTION DEFINUJ_LAT_IBM_U_O		// konverzn pole pre LAT_IBM_U_O W1250 na IBM
*****************************
PUBLIC znakau[255]

*definovanie array znakov pozor vetky musm
znakau[128]:=128
znakau[129]:=129
znakau[130]:=130
znakau[131]:=131
znakau[132]:=132
znakau[133]:=133
znakau[134]:=134
znakau[135]:=135
znakau[136]:=136
znakau[137]:=137
znakau[138]:=83
znakau[139]:=139
znakau[140]:=140
znakau[141]:=84
znakau[142]:=90
znakau[143]:=143
znakau[144]:=144
znakau[145]:=145
znakau[146]:=146
znakau[147]:=147
znakau[148]:=148
znakau[149]:=149
znakau[150]:=150
znakau[151]:=151
znakau[152]:=152
znakau[153]:=153
znakau[154]:=115
znakau[155]:=155
znakau[156]:=156
znakau[157]:=116
znakau[158]:=122
znakau[159]:=159
znakau[160]:=160
znakau[161]:=161
znakau[162]:=162
znakau[163]:=163
znakau[164]:=164
znakau[165]:=165
znakau[166]:=166
znakau[167]:=167
znakau[168]:=168
znakau[169]:=169
znakau[170]:=170
znakau[171]:=171
znakau[172]:=172
znakau[173]:=173
znakau[174]:=174
znakau[175]:=175
znakau[176]:=176
znakau[177]:=177
znakau[178]:=178
znakau[179]:=179
znakau[180]:=180
znakau[181]:=181
znakau[182]:=182
znakau[183]:=183
znakau[184]:=184
znakau[185]:=185
znakau[186]:=186
znakau[187]:=187
znakau[188]:=76
znakau[189]:=189
znakau[190]:=108
znakau[191]:=191
znakau[192]:=82
znakau[193]:=65
znakau[194]:=194
znakau[195]:=195
znakau[196]:=65
znakau[197]:=76
znakau[198]:=198
znakau[199]:=199
znakau[200]:=67
znakau[201]:=69
znakau[202]:=202
znakau[203]:=69
znakau[204]:=69
znakau[205]:=73
znakau[206]:=206
znakau[207]:=68
znakau[208]:=208
znakau[209]:=209
znakau[210]:=78
znakau[211]:=79
znakau[212]:=79
znakau[213]:=79
znakau[214]:=79
znakau[215]:=215
znakau[216]:=82
znakau[217]:=85
znakau[218]:=85
znakau[219]:=85
znakau[220]:=85
znakau[221]:=89
znakau[222]:=222
znakau[223]:=223
znakau[224]:=114
znakau[225]:=97
znakau[226]:=226
znakau[227]:=227
znakau[228]:=97
znakau[229]:=108
znakau[230]:=230
znakau[231]:=231
znakau[232]:=99
znakau[233]:=101
znakau[234]:=234
znakau[235]:=235
znakau[236]:=101
znakau[237]:=105
znakau[238]:=238
znakau[239]:=100
znakau[240]:=240
znakau[241]:=241
znakau[242]:=110
znakau[243]:=111
znakau[244]:=111
znakau[245]:=111
znakau[246]:=111
znakau[247]:=247
znakau[248]:=114
znakau[249]:=117
znakau[250]:=117
znakau[251]:=117
znakau[252]:=117
znakau[253]:=121
znakau[254]:=254
znakau[255]:=255

Return nil


* tu skam poda nvodu xbSession, tj. ako nastavi a posla sprvu klientovi
* ukka ako cez SetCargo ulom dta na server, a potom cez GetCargo zobrazenie tchto dt klientovi
* tu ukka aj ako odovzda SID pri volan cez href, tj. priame volanie funkcie, alebo URL adresy, alebo cez formulr form cez hidden
* to s dve rzne spsoby
********************
FUNCTION WEB_Test1()		// tto funkciu volm cez index.htm a test1.htm
********************
oClient := ThreadObject()					// vytvorenie thread objektu

oClient:SetCargo("messagea", "Come here Watson a")		// nahratie dt/premennej na server, tj. obsah premennej MESSAGE
oClient:SetCargo("messageb", "Come here Watson b")		// nahratie dt/premennej na server, tj. obsah premennej MESSAGE
oClient:SetCargo("messagec", "Come here Watson c")		// nahratie dt/premennej na server, tj. obsah premennej MESSAGE
oClient:SetCargo("messaged", "Come here Watson d")		// nahratie dt/premennej na server, tj. obsah premennej MESSAGE
oClient:SetCargo("messagee", "Come here Watson e")		// nahratie dt/premennej na server, tj. obsah premennej MESSAGE

cID := oClient:GetSessionHandle()				// zistenie SID pre spusten session
*cID := ThreadObject():GetSessionHandle()			// d sa zapsa aj priamo takto 	

* tu je odoslanie html strnky klientovi, tj. riadku Click here , na ktor ke kliknem, tak sa zavol funkcia Test2
oClient:HTTPResponse:Content := "<html><body>"+;
				"<a href=Test2a?_SID="+cID+">Click here a</a><br>"+;			// volanie ako URL s odovzdanm SID	
				"<a href=Test2b?_SID="+cID+">Click here b</a><br>"+;
				"<a href=Test2c?_SID="+cID+">Click here c</a><br>"+;
				"<form name=Test2d method=get action=Test2d>"+;				// volanie ako Form s odovzdanm SID	
					"<input type=hidden name=_SID value="+cID+">"+;
					"<tr><td><input type=submit name=action value=Test2d></td></tr>"+;	
				"</form>"+;
				"<form name=Test2e method=get action=Test2e>"+;				// volanie ako Form s odovzdanm SID	
					"<input type=hidden name=_SID value="+cID+">"+;
					"<tr><td><input type=radio name=radiobutton value=radio1 checked></td></tr>"+;	// zobraz radio button checked tj. predvolen
					"<tr><td><input type=radio name=radiobutton value=radio2></td></tr>"+;	// zobraz radio button
					"<tr><td><input type=radio name=radiobutton value=radio3></td></tr>"+;	// zobraz radio button
					"<tr><td><input type=submit name=action value=Submit></td></tr>"+;	// ale ete to musm potvrdi submitom		
				"</form>"+;
				"</body></html>"
								// _SID=... je vlastne odoslanie parametra _SID funkcii	ale nepochopil som ako 
*poznmka ku radio buttonu :
* name=radiobutton je nzov premennej RADIOBUTTON, ktor potom alej mem zisti cez :getvar
* value=radio1 je nastaven hodnota pre kad button osobitne
								// sa to dostane do WEB_Test... ???
RETURN

********************
FUNCTION WEB_Test2a()		// tto funnkcia je volan z Test1 po kliknut na Click here klientom cez internet prehliada
********************
oClient := ThreadObject()	// znovuotvorenie thread objektu
oClient:HTTPResponse:Content := "<html><body>"+oClient:GetCargo("messagea") +"</body></html>"	// a odoslanie sprvy klientovi ?
RETURN

********************
FUNCTION WEB_Test2b()		// tto funnkcia je volan z Test1 po kliknut na Click here klientom cez internet prehliada
********************
oClient := ThreadObject()	// znovuotvorenie thread objektu
oClient:HTTPResponse:Content := "<html><body>"+oClient:GetCargo("messageb") +"</body></html>"	// a odoslanie sprvy klientovi ?
RETURN

********************
FUNCTION WEB_Test2c()		// tto funnkcia je volan z Test1 po kliknut na Click here klientom cez internet prehliada
********************
oClient := ThreadObject()	// znovuotvorenie thread objektu
oClient:HTTPResponse:Content := "<html><body>"+oClient:GetCargo("messagec") +"</body></html>"	// a odoslanie sprvy klientovi ?
RETURN

********************
FUNCTION WEB_Test2d()		// tto funnkcia je volan z Test1 po kliknut na Click here klientom cez internet prehliada
********************
oClient := ThreadObject()	// znovuotvorenie thread objektu
oClient:HTTPResponse:Content := "<html><body>"+oClient:GetCargo("messaged") +"</body></html>"	// a odoslanie sprvy klientovi ?
RETURN

********************
FUNCTION WEB_Test2e()		// tto funnkcia je volan z Test1 po kliknut na Click here klientom cez internet prehliada
********************
*GETVAR RADIOBUTTON AS lRadio	// toto nefunguje, neviem preo iba ako niie cez oClient:getvar

oClient := ThreadObject()	// znovuotvorenie thread objektu
lRadio:=oClient:getvar("RADIOBUTTON")		// nzov premennej RADIOBUTTON je nastaven pri radio ako name=RADIOBUTTON

if empty(lRADIO)
		oClient:SetCargo("messagee", "Come here Watson e - radio EMPTY")
else
	if lRadio="radio1"
		oClient:SetCargo("messagee", "Come here Watson e - radio 1 ON")
	elseif lRadio="radio2"
		oClient:SetCargo("messagee", "Come here Watson e - radio 2 ON")
	elseif lRadio="radio3"
		oClient:SetCargo("messagee", "Come here Watson e - radio 3 ON")
	else
		oClient:SetCargo("messagee", "Come here Watson e - radio 1,2 OFF")
	endif
endif
oClient:HTTPResponse:Content := "<html><body>"+oClient:GetCargo("messagee") +"</body></html>"	// a odoslanie sprvy klientovi ?
RETURN

